property pFrameworkId

on construct me
pFrameworkId = getVariable("snowwar.gamesystem.id")
executeMessage(#gamesystem_getfacade, getVariable("snowwar.gamesystem.id"))
registerMessage(#create_user, me.getID(), #handleUserCreated)
registerMessage(#game_started, me.getID(), #hideArrowHiliter)
registerMessage(#spectatorMode_off, me.getID(), #handleSpectatorModeOff)
executeMessage(#SetMinigameHandler, getClassVariable("snowwar.minigamehandler.class"))
executeMessage(#pause_messeger_update)
return(1)
end

on deconstruct me
unregisterMessage(#create_user, me.getID())
unregisterMessage(#game_started, me.getID())
executeMessage(#gamesystem_removefacade, getVariable("snowwar.gamesystem.id"))
executeMessage(#resume_messeger_update)
return(1)
end

on prepare me
executeMessage(#hideInfoStand)
tRoomInt = getObject(#room_interface)
if tRoomInt <> 0 then -- jump 43
if getObject(pFrameworkId)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if getObject(pFrameworkId).getSpectatorModeFlag()  = 0 then -- jump 10
tRoomInt.hideRoomBar()
end if -- jump 10 landing
end if -- jump 43 landing
getConnection(#Info).send("G_OBJS")
return(1)
end

on handleSpectatorModeOff me
if getObject(pFrameworkId)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
getObject(pFrameworkId).enterLounge()
return(1)
end

on handleUserCreated me, tName, tUserStrId
tRoomInt = getObject(#room_interface)
if tRoomInt  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tName  = getObject(#session).GET(#userName) then -- jump 12
tRoomInt.showArrowHiliter(tUserStrId)
end if -- jump 12 landing
return(1)
end

on hideArrowHiliter me
tRoomInt = getObject(#room_interface)
if tRoomInt  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tRoomInt.hideArrowHiliter())
end
