property pSkillLevelList, pCreatedAvatarObjList

on construct me
pSkillLevelList = [:]
registerMessage(#create_user, me.getID(), #storeCreatedAvatarInfo)
registerMessage(#userKeywordInput, me.getID(), #showScoresChooser)
return(1)
end

on deconstruct me
unregisterMessage(#create_user, me.getID())
unregisterMessage(#userKeywordInput, me.getID())
return(1)
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #users then -- jump 14
 --TRIMFROMSTACK 1 
return(1)
 -- jump 27
end if -- jump 14 landing
 --PEEKFROMSTACK 0 
--nil--  = #gameplayerinfo
if --nil-- then -- jump 18
 --TRIMFROMSTACK 1 
return(me.storeSkillLevels(tdata))
end if -- jump 18 landing
end if -- jump 27 landing
 --TRIMFROMSTACK 1 
end

on storeCreatedAvatarInfo me, tName, tStrId
if pSkillLevelList.findPos(tStrId) <> 0 then -- jump 23
return(me.showSkillLevel(pSkillLevelList[tStrId]))
end if -- jump 23 landing
return(1)
end

on storeSkillLevels me, tdata
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tdata) <= 1 then -- jump 52 -- backjump 55 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tuser = --nil--
if not me.showSkillLevel(tuser) then -- jump 24
pSkillLevelList.addProp(string(tuser[#id]), tuser)
end if -- jump 24 landing
--nil-- + 1
 -- backjump 55
end if -- jump 52 landing
 --TRIMFROMSTACK 3 
return(1)
end

on showSkillLevel me, tdata
tStrId = string(tdata[#id])
tSkillValue = tdata[#skillvalue]
tSkillLevel = tdata[#skilllevel]
tRoomComponent = getObject(#room_component)
if tRoomComponent  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tUserObj = tRoomComponent.getUserObject(tStrId)
if tUserObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tSkillStr = replaceChunks(getText("sw_user_skill"), "\x", tSkillLevel)
tSkillStr = replaceChunks(tSkillStr, "\y", tSkillValue)
tSkillStr = replaceChunks(tSkillStr, "\r", RETURN)
tUserObj.pCustom = tSkillStr
tUserObj.setProp(#pInfoStruct, #custom, tSkillStr)
return(1)
end

on showScoresChooser me, tKeyword
if tKeyword <> ":roomscore" then -- jump 8
return(0)
end if -- jump 8 landing
tString = EMPTY
tRoomComponent = getObject(#room_component)
if tRoomComponent  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pSkillLevelList) <= 1 then -- jump 84 -- backjump 87 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tItem = --nil--
tUserObj = tRoomComponent.getUserObject(string(tItem[#id]))
if tUserObj <> 0 then -- jump 41
tString = tUserObj.getName() && ":" && tItem[#skillvalue] && " - " && tItem[#skilllevel] & RETURN
end if -- jump 41 landing
--nil-- + 1
 -- backjump 87
end if -- jump 84 landing
 --TRIMFROMSTACK 3 
executeMessage(#alert, tString)
return(1)
end
