property pWindowID, pTimeOutID, pCountdownMember, pDuration, pEndTime

on construct me
pWindowID = getText("gs_title_countdown")
pTimeOutID = "game_countdown_timeout"
return(1)
end

on deconstruct me
return(me.removeGameCountdown())
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #gamereset then -- jump 29
 --TRIMFROMSTACK 1 
return(me.startGameCountdown(tdata[#time_until_game_start], 0))
 -- jump 126
end if -- jump 29 landing
 --PEEKFROMSTACK 0 
--nil--  = #fullgamestatus_time
if --nil-- then -- jump 76
if tdata[#state]  = #started then -- jump 16
 --TRIMFROMSTACK 1 
return(me.removeGameCountdown())
end if -- jump 16 landing
 --TRIMFROMSTACK 1 
return(me.startGameCountdown(tdata[#time_to_next_state], tdata[#state_duration] - tdata[#time_to_next_state]))
 -- jump 44
end if -- jump 76 landing
 --PEEKFROMSTACK 0 
--nil--  = #gamestart
if --nil-- then -- jump 35
playSound("LS-C64-draw-1", void(), [#volume: 170])
 --TRIMFROMSTACK 1 
return(me.removeGameCountdown())
end if -- jump 35 landing
end if -- jump 44 landing
end if -- jump 126 landing
 --TRIMFROMSTACK 1 
return(1)
end

on startGameCountdown me, tSecondsLeft, tSecondsNowElapsed
tMSecLeft = tSecondsLeft * 1000
tDuration = tSecondsLeft + tSecondsNowElapsed * 1000
if tMSecLeft <= 0 then -- jump 8
return(0)
end if -- jump 8 landing
pDuration = tDuration
pEndTime = the milliSeconds + tMSecLeft
if createWindow(pWindowID, "sw_cdown.window") then -- jump 401
tWndObj = getWindow(pWindowID)
if me.getGameSystem().getSpectatorModeFlag() then -- jump 20
tWndObj.getElement("gs_button_leavegame").hide()
 -- jump 3
end if -- jump 3 landing
end if -- jump 20 landing
tWndObj.center()
if me.getGameSystem().getTournamentFlag() or me.getGameSystem().getGameTicketsNotUsedFlag() then -- jump 55
if tWndObj.elementExists("sw_gameprice") then -- jump 17
tWndObj.getElement("sw_gameprice").hide()
end if -- jump 17 landing
if tWndObj.elementExists("bb_win_gameList") then -- jump 17
tWndObj.getElement("bb_win_gameList").hide()
end if -- jump 17 landing
end if -- jump 55 landing
tElem = tWndObj.getElement("gs_bar_cntDwn")
tElem.setProperty(#member, member(getmemnum("sw_scrbar_4")))
tElem.resizeTo(159, 13)
me.setBar(0)
tWndObj.lock()
tWndObj.registerProcedure(#eventProc, me.getID(), #mouseUp)
if timeoutExists(pTimeOutID) then -- jump 11
removeTimeout(pTimeOutID)
end if -- jump 11 landing
createTimeout(pTimeOutID, 300, #setBar, me.getID())
tElem = tWndObj.getElement("gs_numtickets")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if me.getGameSystem()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if me.getGameSystem().getGameTicketsNotUsedFlag() then -- jump 38
tElem.hide()
tElem = tWndObj.getElement("gs_amount_tickets_bg")
if tElem <> 0 then -- jump 10
tElem.hide()
end if -- jump 10 landing
 -- jump 65
end if -- jump 38 landing
tNumTickets = string(me.getGameSystem().getNumTickets())
if tNumTickets.length  = 1 then -- jump 10
tNumTickets = "00" & tNumTickets
end if -- jump 10 landing
if tNumTickets.length  = 2 then -- jump 10
tNumTickets = "0" & tNumTickets
end if -- jump 10 landing
tElem.setText(tNumTickets)
end if -- jump 65 landing
return(1)
 -- jump 8
end if -- jump 401 landing
return(0)
end if -- jump 8 landing
end

on setBar me
tWndObj = getWindow(pWindowID)
if tWndObj  = 0 then -- jump 14
return(me.removeGameCountdown())
end if -- jump 14 landing
tElem = tWndObj.getElement("gs_bar_cntDwn")
if the milliSeconds >= pEndTime then -- jump 14
return(me.removeGameCountdown())
end if -- jump 14 landing
tProc = pEndTime - the milliSeconds / float(pDuration)
tNextWidth = 159 * tProc
tCurrWidth = tElem.getProperty(#width)
if tNextWidth < 80 then -- jump 25
if tNextWidth < 39 then -- jump 10
tmember = "sw_scrbar_1"
 -- jump 7
end if -- jump 10 landing
tmember = "sw_scrbar_3"
end if -- jump 7 landing
 -- jump 7
end if -- jump 25 landing
tmember = "sw_scrbar_4"
end if -- jump 7 landing
tSpr = tElem.getProperty(#sprite)
if pCountdownMember <> tmember then -- jump 27
pCountdownMember = tmember
tElem.setProperty(#member, member(getmemnum(tmember)))
end if -- jump 27 landing
tElem.resizeBy(integer(tNextWidth) - tCurrWidth, 0)
return(1)
end

on removeGameCountdown me
if timeoutExists(pTimeOutID) then -- jump 11
removeTimeout(pTimeOutID)
end if -- jump 11 landing
if windowExists(pWindowID) then -- jump 11
removeWindow(pWindowID)
end if -- jump 11 landing
return(1)
end

on eventProc me, tEvent, tSprID, tParam
 --PEEKFROMSTACK 0 if tSprID  = "gs_button_leavegame" then -- jump 45
if me.getGameSystem()  = 0 then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
me.removeGameCountdown()
 --TRIMFROMSTACK 1 
return(me.getGameSystem().enterLounge())
end if -- jump 45 landing
 --TRIMFROMSTACK 1 
end
