property pFrameworkId, pUserTeamIndex

on construct me
pFrameworkId = getVariable("snowwar.loungesystem.id")
pUserTeamIndex = 0
tSetName = "human.partset.head.sh"
tPartList = []
if variableExists(tSetName) then -- jump 41
tPartList = getVariable(tSetName)
if ilk(tPartList) <> #list then -- jump 11
tPartList = []
 -- jump 12
end if -- jump 11 landing
tPartList = tPartList.duplicate()
end if -- jump 12 landing
end if -- jump 41 landing
tPartList.add("bd")
tPartList.add("sh")
setVariable("snowwar.human.parts.sh", tPartList)
return(1)
end

on deconstruct me
return(1)
end

on getGameSystem me
return(getObject(pFrameworkId))
end

on getUserName me
return(getObject(#session).GET(#userName))
end

on isUserHost me
if me.getGameSystem()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tdata = me.getGameSystem().getObservedInstance()
if tdata  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tHostName = tdata[#host][#name]
return(tHostName  = me.getUserName())
end

on gameCanStart me
tdata = me.getGameSystem().getObservedInstance()
if tdata  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tGameCanStart = tdata[#teams].count  = 1 and tdata[#teams][1][#players].count > 1
if tGameCanStart then -- jump 9
return(1)
end if -- jump 9 landing
tOneTeamOK = 0
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tdata[#teams]) <= 1 then -- jump 52 -- backjump 55 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tTeam = --nil--
if tTeam[#players].count > 0 then -- jump 21
if tOneTeamOK  = 1 then -- jump 9
return(1)
end if -- jump 9 landing
tOneTeamOK = 1
end if -- jump 21 landing
--nil-- + 1
 -- backjump 55
end if -- jump 52 landing
 --TRIMFROMSTACK 3 
return(0)
end

on observeInstance me, tIndexOnList
if me.getGameSystem()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tList = me.getGameSystem().getInstanceList()
if tList  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tIndexOnList > tList.count then -- jump 8
return(0)
end if -- jump 8 landing
if not listp(tList[tIndexOnList]) then -- jump 8
return(0)
end if -- jump 8 landing
tGameId = tList[tIndexOnList][#id]
if me.getGameSystem()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(me.getGameSystem().observeInstance(tGameId))
end

on joinGame me, tTeamIndex
if me.getGameSystem()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tParamList = me.getGameSystem().getJoinParameters()
if tTeamIndex  = 0 then -- jump 8
tTeamIndex = pUserTeamIndex
end if -- jump 8 landing
if tTeamIndex  = 0 then -- jump 12
tTeamIndex = me.getUserTeamIndex()
end if -- jump 12 landing
tInstance = me.getGameSystem().getObservedInstance()
tInstanceId = tInstance[#id]
if not listp(tParamList) then -- jump 22
return(me.getGameSystem().initiateJoinGame(tInstanceId, tTeamIndex))
end if -- jump 22 landing
return(me.getGameSystem().joinGame(void(), tInstanceId, tTeamIndex, tParamList))
end

on checkUserWasKicked me
if pUserTeamIndex <> 0 then -- jump 21
if me.getUserTeamIndex()  = 0 then -- jump 9
return(1)
end if -- jump 9 landing
end if -- jump 21 landing
return(0)
end

on saveUserTeamIndex me
pUserTeamIndex = me.getUserTeamIndex()
return(1)
end

on resetUserTeamIndex me
pUserTeamIndex = 0
return(1)
end

on getUserTeamIndex me
return(me.getPlayerTeamIndex([#name: me.getUserName()]))
end

on getPlayerTeamIndex me, tSearchData
if me.getGameSystem()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tdata = me.getGameSystem().getObservedInstance()
if tdata[#teams]  = void() then -- jump 8
return(0)
end if -- jump 8 landing
tTeamNum = 1
if tTeamNum <= tdata[#teams].count then -- jump 170 -- backjump 182 landing
tTeam = tdata[#teams][tTeamNum][#players]
if not listp(tTeam) then -- jump 8
tTeam = []
end if -- jump 8 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tTeam) <= 1 then -- jump 101 -- backjump 104 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPlayer = --nil--
if tPlayer[#name]  = tSearchData[#name] and tSearchData[#name] <> void() then -- jump 9
return(tTeamNum)
end if -- jump 9 landing
if tPlayer[#id]  = tSearchData[#id] and tSearchData[#id] <> void() then -- jump 9
return(tTeamNum)
end if -- jump 9 landing
--nil-- + 1
 -- backjump 104
end if -- jump 101 landing
 --TRIMFROMSTACK 3 
tTeamNum = 1 + tTeamNum
 -- backjump 182
end if -- jump 170 landing
return(0)
end
