property pObjectCache

on construct me
return(1)
end

on deconstruct me
pObjectCache = void()
return(1)
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #gameend then -- jump 46
if getObject(#session).exists("user_game_index") then -- jump 28
me.getGameSystem().executeGameObjectEvent(getObject(#session).GET("user_game_index"), #gameend)
end if -- jump 28 landing
 -- jump 220
end if -- jump 46 landing
 --PEEKFROMSTACK 0 
--nil--  = #update_game_object
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.updateGameObject(tdata))
 -- jump 193
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = #verify_game_object_id_list
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.verifyGameObjectList(tdata))
 -- jump 166
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil-- <> #snowwar_event_0
if --nil-- then -- jump 12
 --PEEKFROMSTACK 0 
--nil--  = #create_game_object
if --nil-- then -- jump 21
end if -- jump 12 landing
 --TRIMFROMSTACK 1 
return(me.createGameObject(tdata))
 -- jump 130
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil-- <> #snowwar_event_1
if --nil-- then -- jump 12
 --PEEKFROMSTACK 0 
--nil--  = #remove_game_object
if --nil-- then -- jump 27
end if -- jump 12 landing
 --TRIMFROMSTACK 1 
return(me.removeGameObject(tdata[#id]))
 -- jump 88
end if -- jump 27 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_8
if --nil-- then -- jump 27
playSound("LS-throw")
 --TRIMFROMSTACK 1 
return(me.createSnowballGameObject(tdata))
 -- jump 55
end if -- jump 27 landing
 --PEEKFROMSTACK 0 
--nil--  = #world_ready
if --nil-- then -- jump 19
 --TRIMFROMSTACK 1 
return(me.createStoredObjects())
 -- jump 30
end if -- jump 19 landing
 --TRIMFROMSTACK 1 
return(error(me, "Undefined event!" && tTopic && "for" && me.pID, #Refresh))
end if -- jump 30 landing
end if -- jump 55 landing
end if -- jump 88 landing
end if -- jump 130 landing
end if -- jump 166 landing
end if -- jump 193 landing
end if -- jump 220 landing
 --TRIMFROMSTACK 1 
end

on createStoredObjects me
if pObjectCache  = void() then -- jump 9
return(1)
end if -- jump 9 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pObjectCache) <= 1 then -- jump 27 -- backjump 30 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tDataObject = --nil--
me.createGameObject(tDataObject)
--nil-- + 1
 -- backjump 30
end if -- jump 27 landing
 --TRIMFROMSTACK 3 
pObjectCache = void()
end

on createGameObject me, tDataObject
tGameSystem = me.getGameSystem()
if tGameSystem.getWorldReady()  = 0 then -- jump 35
if pObjectCache  = void() then -- jump 9
pObjectCache = []
end if -- jump 9 landing
pObjectCache.add(tDataObject)
return(1)
end if -- jump 35 landing
tGameSystem.createGameObject(tDataObject[#id], tDataObject[#str_type], tDataObject[#objectDataStruct])
tGameObject = tGameSystem.getGameObject(tDataObject[#id])
if tGameObject  = 0 then -- jump 27
return(error(me, "Unable to create game object:" && tDataObject[#id], #createGameObject))
end if -- jump 27 landing
tGameObject.setGameObjectProperty(tDataObject)
tGameObject.define(tDataObject)
return(1)
end

on updateGameObject me, tDataObject
tGameSystem = me.getGameSystem()
tGameObject = tGameSystem.getGameObject(tDataObject[#id])
if tGameObject  = 0 then -- jump 27
return(error(me, "Game object not found:" && tDataObject[#id], #updateGameObject))
end if -- jump 27 landing
tOldValues = tGameObject.pGameObjectSyncValues
tNewValues = tDataObject[#objectDataStruct]
i = 1
if i <= tNewValues.count then -- jump 85 -- backjump 90 landing
tKey = tNewValues.getPropAt(i)
if tOldValues[tKey] <> tNewValues[tKey] then -- jump 45
put("** Obj" && tDataObject[#id] && "NOT IN SYNC:" && tKey && tOldValues[tKey] & ", server says:" && tNewValues[tKey])
end if -- jump 45 landing
i = 1 + i
 -- backjump 90
end if -- jump 85 landing
tGameSystem.updateGameObject(tDataObject[#id], tDataObject[#objectDataStruct])
return(tGameObject.define(tDataObject))
end

on removeGameObject me, tObjectID
tGameSystem = me.getGameSystem()
return(tGameSystem.removeGameObject(tObjectID))
end

on verifyGameObjectList me, tObjectIdList
tGameSystem = me.getGameSystem()
tAllGameObjectIds = tGameSystem.getGameObjectIdsOfType(#all)
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tAllGameObjectIds) <= 1 then -- jump 42 -- backjump 45 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObjectID = --nil--
if tObjectIdList.getPos(tObjectID) < 1 then -- jump 12
tGameSystem.removeGameObject(tObjectID)
end if -- jump 12 landing
--nil-- + 1
 -- backjump 45
end if -- jump 42 landing
 --TRIMFROMSTACK 3 
return(1)
end

on createSnowballGameObject me, tdata
tGameSystem = me.getGameSystem()
tThrowerObject = tGameSystem.getGameObject(string(tdata.int_thrower_id))
tThrowerLoc = tThrowerObject.getLocation()
tGameObjectStruct = [:]
tGameObjectStruct.addProp(#type, 1)
tGameObjectStruct.addProp(#int_id, tdata.int_id)
tGameObjectStruct.addProp(#id, tdata.id)
tGameObjectStruct.addProp(#x, tThrowerLoc.x)
tGameObjectStruct.addProp(#y, tThrowerLoc.y)
tGameObjectStruct.addProp(#z, tThrowerLoc.z)
tGameObjectStruct.addProp(#movement_direction, 0)
tGameObjectStruct.addProp(#trajectory, tdata.trajectory)
tGameObjectStruct.addProp(#time_to_live, 0)
tGameObjectStruct.addProp(#int_thrower_id, tdata.int_thrower_id)
tGameObjectStruct.addProp(#parabola_offset, 0)
tObject = tGameSystem.createGameObject(tdata[#id], "snowball", tGameObjectStruct)
if tObject  = 0 then -- jump 18
return(error(me, "Cannot create snowball object!", #createSnowballGameObject))
end if -- jump 18 landing
tObject.define(tGameObjectStruct)
tObject.calculateFlightPath(tGameObjectStruct, tdata.targetX, tdata.targetY)
return(1)
end
