property pNameSpriteNum, pBottomSpriteNum, pNameFieldMemName

on display me, tName, tScore, tTeamId, tloc, tOwnPlayer
if not stringp(tName) then -- jump 18
return(error(me, "String expected by hiliter.", #display))
end if -- jump 18 landing
pNameSpriteNum = reserveSprite("sw_hiliter1_" & tName & tTeamId)
pBottomSpriteNum = reserveSprite("sw_hiliter2_" & tName & tTeamId)
if pNameSpriteNum  = 0 or pBottomSpriteNum  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tText = getText("gs_mouseover_player")
tText = replaceChunks(tText, "\x", tName)
tText = replaceChunks(tText, "\r", RETURN)
tText = replaceChunks(tText, "\y", tScore)
tmember = me.getNameFieldMember(tText, tTeamId)
tsprite = sprite(pNameSpriteNum)
if tmember <> 0 then -- jump 9
tsprite.member = tmember
end if -- jump 9 landing
tsprite.locZ = 1000000
tsprite.loc = point(tloc[1] - tmember.width / 2, tloc[2] + 10)
tsprite.ink = 36
if not tOwnPlayer then -- jump 88
tmember = member(getmemnum("sw_avatar_hilite_team_" & tTeamId))
tsprite = sprite(pBottomSpriteNum)
if tmember.type  = #bitmap then -- jump 9
tsprite.member = tmember
end if -- jump 9 landing
tsprite.locZ = tloc[3] - 1
tsprite.loc = point(tloc[1], tloc[2])
tsprite.ink = 36
end if -- jump 88 landing
return(1)
end

on hide me
if memberExists(pNameFieldMemName) then -- jump 11
removeMember(pNameFieldMemName)
end if -- jump 11 landing
if pNameSpriteNum > 0 then -- jump 10
releaseSprite(pNameSpriteNum)
end if -- jump 10 landing
if pBottomSpriteNum > 0 then -- jump 10
releaseSprite(pBottomSpriteNum)
end if -- jump 10 landing
pNameSpriteNum = void()
pBottomSpriteNum = void()
return(0)
end

on getNameFieldMember me, tText, tTeamId
pNameFieldMemName = "____sw_hilite_field"
if not memberExists(pNameFieldMemName) then -- jump 23
tNameFieldMem = member(createMember(pNameFieldMemName, #text))
 -- jump 13
end if -- jump 23 landing
tNameFieldMem = getMember(pNameFieldMemName)
end if -- jump 13 landing
if tNameFieldMem.type  = #empty then -- jump 8
return(0)
end if -- jump 8 landing
tTeamColor = rgb(string(getVariable("snowwar.teamcolors.team" & tTeamId)))
tFontStruct = getStructVariable("struct.font.bold")
tNameFieldMem.color = tTeamColor
tNameFieldMem.fontSize = tFontStruct[#fontSize]
tNameFieldMem.alignment = #center
tNameFieldMem.fontStyle = tFontStruct[#fontStyle]
tNameFieldMem.font = tFontStruct[#font]
tNameFieldMem.text = tText
return(tNameFieldMem)
end
