property pRoomGeometry, pMouseClickTime

on construct me
me.registerEventProc(1)
return(1)
end

on deconstruct me
me.registerEventProc(0)
if managerExists(#sound_manager) then -- jump 8
stopAllSounds()
end if -- jump 8 landing
return(1)
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #objects_ready then -- jump 13
me.processRoomReady()
 -- jump 119
end if -- jump 13 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_11
if --nil-- then -- jump 32
me.getGameSystem().executeGameObjectEvent(string(tdata[#int_machine_id]), #add_snowball)
 -- jump 81
end if -- jump 32 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_12
if --nil-- then -- jump 45
 --TRIMFROMSTACK 1 
return(me.moveBallsToUser(string(tdata[#int_machine_id]), string(tdata[#int_player_id])))
 -- jump 30
end if -- jump 45 landing
 --TRIMFROMSTACK 1 
return(error(me, "Undefined event!" && tTopic && "for" && me.pID, #Refresh))
end if -- jump 30 landing
end if -- jump 81 landing
end if -- jump 119 landing
 --TRIMFROMSTACK 1 
return(1)
end

on processRoomReady me
tList = getObject(#room_component).pPassiveObjList
tTargetID = getThread(#room).getInterface().getID()
tVisObj = getObject("Room_visualizer")
tBaseLocZ = tVisObj.getProperty(#locZ)
tBaseLocZ = tVisObj.getSprById("floor").locZ
tHiliterLocZ = tVisObj.getSprById("hiliter").locZ
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tList) <= 1 then -- jump 142 -- backjump 145 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObject = --nil--
tSprites = tObject.getSprites()
if tSprites.count > 0 then -- jump 109
tSpr = tSprites[1]
tSpr.removeProcedure(#eventProcPassiveObj, tTargetID)
tSpr.registerProcedure(#eventProcRoom, me.getID(), #mouseDown)
tSpr.registerProcedure(#eventProcRoom, me.getID(), #mouseUp)
if tSpr.member.name contains "sw_backround" then -- jump 38
tSpr.locZ = tBaseLocZ + 1
if tSpr.locZ >= tHiliterLocZ then -- jump 19
tVisObj.getSprById("hiliter").locZ = tHiliterLocZ + 1
end if -- jump 19 landing
end if -- jump 38 landing
end if -- jump 109 landing
--nil-- + 1
 -- backjump 145
end if -- jump 142 landing
 --TRIMFROMSTACK 3 
end

on registerEventProc me, tBoolean
tRoomThread = getThread(#room)
if tRoomThread  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tRoomInt = tRoomThread.getInterface()
if tRoomInt  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
pRoomGeometry = tRoomInt.getGeometry()
if pRoomGeometry  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tVisObj = tRoomInt.getRoomVisualizer()
if tVisObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tSprList = tVisObj.getProperty(#spriteList)
if tBoolean then -- jump 70
call(#removeProcedure, tSprList, #mouseDown)
call(#removeProcedure, tSprList, #mouseUp)
call(#registerProcedure, tSprList, #eventProcRoom, me.getID(), #mouseDown)
call(#registerProcedure, tSprList, #eventProcRoom, me.getID(), #mouseUp)
 -- jump 37
end if -- jump 70 landing
if listp(tSprList) then -- jump 27
call(#removeProcedure, tSprList, #mouseDown)
call(#removeProcedure, tSprList, #mouseUp)
end if -- jump 27 landing
end if -- jump 37 landing
end

on eventProcRoom me, tEvent, tSprID, tParam
tloc = pRoomGeometry.getWorldCoordinate(the mouseH, the mouseV)
if not listp(tloc) then -- jump 9
return(1)
end if -- jump 9 landing
tRoomInt = getObject(#room_interface)
if tRoomInt  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tRoomInt.getComponent().getSpectatorMode() then -- jump 9
return(1)
end if -- jump 9 landing
if tEvent  = #mouseUp then -- jump 103
tMouseDownTime = the milliSeconds - pMouseClickTime / 1000
if the optionDown then -- jump 24
pMouseClickTime = -1
return(me.sendThrowBall(tloc, 2))
end if -- jump 24 landing
if the shiftDown then -- jump 44
if tMouseDownTime >= 1 then -- jump 21
return(me.sendThrowBall(tloc, 2))
 -- jump 18
end if -- jump 21 landing
return(me.sendThrowBall(tloc, 1))
end if -- jump 18 landing
end if -- jump 44 landing
pMouseClickTime = -1
return(1)
end if -- jump 103 landing
if tEvent  = #mouseDown then -- jump 45
if the shiftDown then -- jump 11
pMouseClickTime = the milliSeconds
 -- jump 24
end if -- jump 11 landing
if not the optionDown then -- jump 16
return(me.sendMoveGoal(tloc))
end if -- jump 16 landing
end if -- jump 24 landing
return(1)
end if -- jump 45 landing
end

on sendThrowBall me, tloc, tTrajectory
tFramework = me.getGameSystem()
if tFramework  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tGameState = tFramework.getGamestatus()
if tGameState  = #game_started then -- jump 92
tWorldLoc = tFramework.convertTileToWorldCoordinate(tloc[1], tloc[2])
if not getObject(#session).exists("user_game_index") then -- jump 8
return(0)
end if -- jump 8 landing
tMyId = getObject(#session).GET("user_game_index")
tFramework.executeGameObjectEvent(tMyId, #send_throw_at_loc, [#targetloc: tWorldLoc, #trajectory: tTrajectory])
return(1)
end if -- jump 92 landing
end

on sendMoveGoal me, tloc
tFramework = me.getGameSystem()
if tFramework  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tGameState = tFramework.getGamestatus()
if tGameState  = #game_started then -- jump 81
if not getObject(#session).exists("user_game_index") then -- jump 8
return(0)
end if -- jump 8 landing
tMyId = getObject(#session).GET("user_game_index")
return(tFramework.executeGameObjectEvent(tMyId, #send_set_target_tile, [#tile_x: tloc[1], #tile_y: tloc[2]]))
 -- jump 30
end if -- jump 81 landing
return(tFramework.sendHabboRoomMove(tloc[1], tloc[2]))
end if -- jump 30 landing
end

on moveBallsToUser me, tMachineID, tUserID
tMachineObject = me.getGameSystem().getGameObject(tMachineID)
if tMachineObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tMachineBallCount = tMachineObject.getGameObjectProperty(#snowball_count)
tUserObject = me.getGameSystem().getGameObject(tUserID)
if tUserObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tUserBallCount = tUserObject.getGameObjectProperty(#snowball_count)
tMaxBallCount = getIntVariable("snowwar.snowball.maximum")
if tMachineBallCount > 0 and tUserBallCount < tMaxBallCount then -- jump 44
me.getGameSystem().executeGameObjectEvent(tUserID, #set_ball_count, [#value: tUserBallCount + 1])
me.getGameSystem().executeGameObjectEvent(tMachineID, #remove_snowball)
end if -- jump 44 landing
return(1)
end
