property pNumTeams, pRoomComponentObj, pFigureSystemObj, pHiliterObj

on construct me
pRoomComponentObj = getObject(#room_component)
if pRoomComponentObj  = 0 then -- jump 17
return(error(me, "Avatar manager failed to initialize", #construct))
end if -- jump 17 landing
registerMessage(#create_user, me.getID(), #setAvatarEventListener)
return(1)
end

on deconstruct me
me.displayAvatarInfo(0)
unregisterMessage(#create_user, me.getID())
getObject(#session).Remove("game_number_of_teams")
return(1)
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #set_number_of_teams then -- jump 24
pNumTeams = tdata
getObject(#session).set("game_number_of_teams", tdata)
 -- jump 516
end if -- jump 24 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_2
if --nil-- then -- jump 28
me.getGameSystem().executeGameObjectEvent(tdata[#id], #set_target, tdata)
 -- jump 483
end if -- jump 28 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_3
if --nil-- then -- jump 48
me.getGameSystem().executeGameObjectEvent(tdata[#id], #start_throw_snowball, tdata)
me.getGameSystem().executeGameObjectEvent(tdata[#id], #substract_ball_count)
 -- jump 430
end if -- jump 48 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_4
if --nil-- then -- jump 48
me.getGameSystem().executeGameObjectEvent(tdata[#id], #start_throw_snowball, tdata)
me.getGameSystem().executeGameObjectEvent(tdata[#id], #substract_ball_count)
 -- jump 377
end if -- jump 48 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_5
if --nil-- then -- jump 135
playSound("LS-hit-" & random(2))
tGameSystem = me.getGameSystem()
tGameSystem.executeGameObjectEvent(tdata[#id], #substract_hit_points)
if pNumTeams  = 1 then -- jump 10
tAwardScore = 1
 -- jump 55
end if -- jump 10 landing
tThisTeam = tGameSystem.getGameObjectProperty(tdata[#id], #team_id)
tThatTeam = tGameSystem.getGameObjectProperty(string(tdata[#int_thrower_id]), #team_id)
if tThisTeam <> tThatTeam then -- jump 7
tAwardScore = 1
end if -- jump 7 landing
end if -- jump 55 landing
if tAwardScore then -- jump 23
tGameSystem.executeGameObjectEvent(string(tdata[#int_thrower_id]), #award_hit_score)
end if -- jump 23 landing
 -- jump 237
end if -- jump 135 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_7
if --nil-- then -- jump 26
me.getGameSystem().executeGameObjectEvent(tdata[#id], #start_create_snowball)
 -- jump 206
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = #snowwar_event_9
if --nil-- then -- jump 171
tGameSystem = me.getGameSystem()
tHitDirection8 = tGameSystem.getGeometry().direction360to8(tdata[#hit_direction])
playSound("LS-hit-3")
tGameSystem.executeGameObjectEvent(tdata[#id], #start_stunned, [#hit_direction: tHitDirection8])
tGameSystem.executeGameObjectEvent(tdata[#id], #zero_ball_count)
if pNumTeams  = 1 then -- jump 10
tAwardScore = 1
 -- jump 55
end if -- jump 10 landing
tThisTeam = tGameSystem.getGameObjectProperty(tdata[#id], #team_id)
tThatTeam = tGameSystem.getGameObjectProperty(string(tdata[#int_thrower_id]), #team_id)
if tThisTeam <> tThatTeam then -- jump 7
tAwardScore = 1
end if -- jump 7 landing
end if -- jump 55 landing
if tAwardScore then -- jump 23
tGameSystem.executeGameObjectEvent(string(tdata[#int_thrower_id]), #award_kill_score)
end if -- jump 23 landing
 -- jump 30
end if -- jump 171 landing
 --TRIMFROMSTACK 1 
return(error(me, "Undefined event!" && tTopic && "for" && me.pID, #Refresh))
end if -- jump 30 landing
end if -- jump 206 landing
end if -- jump 237 landing
end if -- jump 377 landing
end if -- jump 430 landing
end if -- jump 483 landing
end if -- jump 516 landing
 --TRIMFROMSTACK 1 
return(1)
end

on setAvatarEventListener me, tName, tID
tRoom = getObject(#room_component)
if tRoom  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tObject = tRoom.getUserObject(tID)
if tObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
call(#setAvatarEventListener, tObject, me.getID())
return(1)
end

on eventProcSnowwarUserRollOver me, tEvent, tID, tProp
tRoom = getObject(#room_component)
if tRoom  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tObject = tRoom.getUserObject(tID)
if tObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tGameSystem = me.getGameSystem()
if tEvent  = #mouseEnter then -- jump 208
tName = tObject.getName()
tOwnPlayer = 0
if not tGameSystem.getSpectatorModeFlag() then -- jump 81
if tName  = getObject(#session).GET(#userName) then -- jump 10
tOwnPlayer = 1
 -- jump 55
end if -- jump 10 landing
if tGameSystem.getGamestatus()  = #game_started then -- jump 43
tMemberNum = getmemnum("sw_crosshair")
tMemberNum2 = getmemnum("sw_crosshair.mask")
if tMemberNum <> 0 and tMemberNum2 <> 0 then -- jump 15
cursor([tMemberNum, tMemberNum2])
end if -- jump 15 landing
end if -- jump 43 landing
end if -- jump 55 landing
end if -- jump 81 landing
tloc = tObject.getLocation()
tloc = tGameSystem.convertTileToWorldCoordinate(tloc[1], tloc[2], 0)
tloc = tGameSystem.convertWorldToScreenCoordinate(tloc[1], tloc[2], 0)
tScore = tGameSystem.getGameObjectProperty(tObject.getAvatarId(), #score)
return(me.displayAvatarInfo(tName, tScore, tObject.getTeamId(), tloc, tOwnPlayer))
 -- jump 20
end if -- jump 208 landing
setcursor(0)
return(me.displayAvatarInfo(0))
end if -- jump 20 landing
end

on displayAvatarInfo me, tName, tScore, tTeamId, tloc, tOwnPlayer
if stringp(tName) then -- jump 76
if pHiliterObj <> void() then -- jump 9
return(1)
end if -- jump 9 landing
pHiliterObj = createObject(#temp, getClassVariable("snowwar.object_avatar.roomobject.hiliter.class"))
if pHiliterObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(pHiliterObj.display(tName, tScore, tTeamId, tloc, tOwnPlayer))
 -- jump 29
end if -- jump 76 landing
if pHiliterObj <> void() then -- jump 11
pHiliterObj.hide()
end if -- jump 11 landing
pHiliterObj = void()
end if -- jump 29 landing
return(1)
end
