property pBottomBarId, pMaxHealth, pMaxHealthBarHeight, pOrigHealthBarLoc, pLastHealth, pLastBallcount, pMaxBallcount, pBallCountAnimTimer, pBallCreateAnimTimer

on construct me
pBallCountAnimTimer = 0
pBallCreateAnimTimer = 0
pBottomBarId = "RoomBarID"
registerMessage(#roomReady, me.getID(), #replaceRoomBar)
registerMessage(#updateInfostandAvatar, me.getID(), #updateRoomBarFigure)
pMaxHealth = getIntVariable("snowwar.health.maximum")
pMaxBallcount = getIntVariable("snowwar.snowball.maximum")
pLastHealth = pMaxHealth
return(1)
end

on deconstruct me
unregisterMessage(#roomReady, me.getID())
unregisterMessage(#updateInfostandAvatar, me.getID())
removeWindow(pBottomBarId)
return(1)
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #gamestart then -- jump 22
 --TRIMFROMSTACK 1 
return(me.updateBallCount(pLastBallcount))
 -- jump 186
end if -- jump 22 landing
 --PEEKFROMSTACK 0 
--nil--  = #gameend
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setCreateButtonState("_off"))
 -- jump 159
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = #update_game_visuals
if --nil-- then -- jump 19
 --TRIMFROMSTACK 1 
return(me.updateGameVisuals())
 -- jump 134
end if -- jump 19 landing
 --PEEKFROMSTACK 0 
--nil--  = #statusbar_health_update
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.updateHealth(tdata))
 -- jump 107
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = #statusbar_ballcount_update
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.updateBallCount(tdata))
 -- jump 80
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = #statusbar_createball_started
if --nil-- then -- jump 19
 --TRIMFROMSTACK 1 
return(me.animateBallCreateStarted())
 -- jump 55
end if -- jump 19 landing
 --PEEKFROMSTACK 0 
--nil--  = #statusbar_createball_stopped
if --nil-- then -- jump 22
 --TRIMFROMSTACK 1 
return(me.updateBallCount(pLastBallcount))
 -- jump 27
end if -- jump 22 landing
 --PEEKFROMSTACK 0 
--nil--  = #statusbar_disable_buttons
if --nil-- then -- jump 18
 --TRIMFROMSTACK 1 
return(me.setCreateButtonState("_off"))
end if -- jump 18 landing
end if -- jump 27 landing
end if -- jump 55 landing
end if -- jump 80 landing
end if -- jump 107 landing
end if -- jump 134 landing
end if -- jump 159 landing
end if -- jump 186 landing
 --TRIMFROMSTACK 1 
return(1)
end

on update me
if pBallCountAnimTimer > 0 then -- jump 10
me.animateBallCountFlashing()
end if -- jump 10 landing
if pBallCreateAnimTimer > 0 then -- jump 10
me.animateBallCreateStarted()
end if -- jump 10 landing
end

on updateGameVisuals me
if not getObject(#session).exists("user_game_index") then -- jump 8
return(0)
end if -- jump 8 landing
tObjectID = getObject(#session).GET("user_game_index")
tHealth = me.getGameSystem().getGameObjectProperty(tObjectID, #hit_points)
tBallCount = me.getGameSystem().getGameObjectProperty(tObjectID, #snowball_count)
me.updateHealth(tHealth)
me.updateBallCount(tBallCount)
return(1)
end

on updateHealth me, tValue
if pMaxHealth  = void() then -- jump 8
return(0)
end if -- jump 8 landing
pLastHealth = tValue
tWndObj = getWindow(pBottomBarId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("snowwar_bar_hit_points")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if pOrigHealthBarLoc  = void() then -- jump 28
pOrigHealthBarLoc = point(tElem.getProperty(#locH), tElem.getProperty(#locV))
end if -- jump 28 landing
tPercent = tValue * 1.0 / pMaxHealth
if tPercent > 0.7 then -- jump 10
tmember = "ui_healthbar_green"
 -- jump 22
end if -- jump 10 landing
if tPercent > 0.3 then -- jump 10
tmember = "ui_healthbar_yellow"
 -- jump 7
end if -- jump 10 landing
tmember = "ui_healthbar_red"
end if -- jump 7 landing
end if -- jump 22 landing
if tElem.getProperty(#member) <> tmember then -- jump 22
tElem.setProperty(#member, member(getmemnum(tmember)))
end if -- jump 22 landing
tElemHeight = tElem.getProperty(#height)
tElemLocV = tElem.getProperty(#locV)
if tValue  = pMaxHealth then -- jump 8
pMaxHealthBarHeight = tElemHeight
end if -- jump 8 landing
tHeightAdjust = integer(tPercent * pMaxHealthBarHeight - tElemHeight)
tTotalAdjust = pMaxHealthBarHeight - tElemHeight + tHeightAdjust
tElem.resizeBy(0, tHeightAdjust)
tElem.moveTo(pOrigHealthBarLoc.locH, pOrigHealthBarLoc.locV + tTotalAdjust)
return(1)
end

on updateBallCount me, tValue
if pMaxBallcount  = void() then -- jump 8
return(0)
end if -- jump 8 landing
pLastBallcount = tValue
tWndObj = getWindow(pBottomBarId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tBallNum = 1
if tBallNum <= pMaxBallcount then -- jump 47 -- backjump 51 landing
tElem = tWndObj.getElement("snowball_" & tBallNum)
if tElem <> 0 then -- jump 17
tElem.setProperty(#visible, tBallNum <= tValue)
end if -- jump 17 landing
tBallNum = 1 + tBallNum
 -- backjump 51
end if -- jump 47 landing
 --PEEKFROMSTACK 0 if tValue  = pMaxBallcount then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setCreateButtonState("_off"))
 -- jump 57
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = 0
if --nil-- then -- jump 35
if pLastHealth  = 0 then -- jump 11
 --TRIMFROMSTACK 1 
return(1)
end if -- jump 11 landing
 --TRIMFROMSTACK 1 
return(me.animateBallCountFlashing())
 -- jump 18
end if -- jump 35 landing
 --TRIMFROMSTACK 1 
return(me.setCreateButtonState(EMPTY))
end if -- jump 18 landing
end if -- jump 57 landing
 --TRIMFROMSTACK 1 
end

on animateBallCountFlashing me
if pBallCountAnimTimer  = 0 then -- jump 22
pBallCountAnimTimer = 1
receiveUpdate(me.getID())
 -- jump 39
end if -- jump 22 landing
if pBallCountAnimTimer >= 50 then -- jump 21
removeUpdate(me.getID())
pBallCountAnimTimer = 0
 -- jump 12
end if -- jump 21 landing
pBallCountAnimTimer = pBallCountAnimTimer + 1
end if -- jump 12 landing
end if -- jump 39 landing
tWndObj = getWindow(pBottomBarId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tMemNum = 1 + pBallCountAnimTimer / 4 mod 2
tMemName = ["ui_snowball_slots", "ui_snowball_slots_hilite"][tMemNum]
tElem = tWndObj.getElement("int_alapalkki_balls_bg")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tElem.getProperty(#member).name  = tMemName then -- jump 9
return(1)
end if -- jump 9 landing
tElem.setProperty(#member, member(getmemnum(tMemName)))
tMemName = [EMPTY, "_hilite"][tMemNum]
me.setCreateButtonState(tMemName)
return(1)
end

on animateBallCreateStarted me
if pBallCreateAnimTimer  = 0 then -- jump 31
pBallCreateAnimTimer = 1
me.setCreateButtonState("_pressed")
receiveUpdate(me.getID())
 -- jump 48
end if -- jump 31 landing
if pBallCreateAnimTimer >= 3 then -- jump 30
removeUpdate(me.getID())
me.setCreateButtonState("_off")
pBallCreateAnimTimer = 0
 -- jump 12
end if -- jump 30 landing
pBallCreateAnimTimer = pBallCreateAnimTimer + 1
end if -- jump 12 landing
end if -- jump 48 landing
end

on setCreateButtonState me, tstate
tWndObj = getWindow(pBottomBarId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("snowwar_button_create")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tMemName = "ui_makesnowballgreen" & tstate
if tElem.getProperty(#member).name  = tMemName then -- jump 9
return(1)
end if -- jump 9 landing
tMemNum = getmemnum(tMemName)
if tMemNum  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tsprite = tElem.getProperty(#sprite)
if tsprite <> 0 then -- jump 31
if tstate  = "_off" then -- jump 14
tsprite.setcursor(0)
 -- jump 12
end if -- jump 14 landing
tsprite.setcursor("cursor.finger")
end if -- jump 12 landing
end if -- jump 31 landing
tElem.setProperty(#member, member(tMemNum))
return(1)
end

on updateSoundIcon me
tWndObj = getWindow(pBottomBarId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_int_sound_image")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if getSoundState() then -- jump 10
tMemName = "sw_soundon"
 -- jump 7
end if -- jump 10 landing
tMemName = "sw_soundoff"
end if -- jump 7 landing
tmember = member(getmemnum(tMemName))
if tmember.type  = #bitmap then -- jump 14
tElem.feedImage(tmember.image)
end if -- jump 14 landing
return(1)
end

on replaceRoomBar me
tSpectator = me.getGameSystem().getSpectatorModeFlag()
if tSpectator then -- jump 9
return(1)
end if -- jump 9 landing
removeWindow(pBottomBarId)
createWindow(pBottomBarId, "empty.window", 0, 471)
tWndObj = getWindow(pBottomBarId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tWndObj.lock(1)
tWndObj.unmerge()
tLayout = "sw_ui.window"
if not tWndObj.merge(tLayout) then -- jump 8
return(0)
end if -- jump 8 landing
me.updateRoomBarFigure()
tWndObj.registerClient(me.getID())
tWndObj.registerProcedure(#eventProcRoomBar, me.getID(), #mouseUp)
tWndObj.registerProcedure(#eventProcRoomBar, me.getID(), #keyDown)
tWndObj.registerProcedure(#eventProcRoomBar, me.getID(), #mouseEnter)
tWndObj.registerProcedure(#eventProcRoomBar, me.getID(), #mouseLeave)
me.updateSoundIcon()
me.setCreateButtonState("_off")
return(1)
end

on updateRoomBarFigure me
tSpectator = me.getGameSystem().getSpectatorModeFlag()
if not tSpectator and objectExists("Figure_Preview") then -- jump 22
getObject("Figure_Preview").createHumanPartPreview(pBottomBarId, "snowwar_avatar_face", #head)
end if -- jump 22 landing
end

on eventProcRoomBar me, tEvent, tSprID, tParam
if tEvent  = #mouseUp then -- jump 103
 --PEEKFROMSTACK 0 if tSprID  = "snowwar_button_create" then -- jump 59
if not getObject(#session).exists("user_game_index") then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
 --TRIMFROMSTACK 1 
return(me.getGameSystem().executeGameObjectEvent(getObject(#session).GET("user_game_index"), #send_create_snowball))
 -- jump 35
end if -- jump 59 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_int_sound_image"
if --nil-- then -- jump 27
setSoundState(not getSoundState())
 --TRIMFROMSTACK 1 
return(me.updateSoundIcon())
end if -- jump 27 landing
end if -- jump 35 landing
 --TRIMFROMSTACK 1 
end if -- jump 103 landing
tRoomInt = getObject("RoomBarProgram")
if tRoomInt  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tRoomInt.eventProcRoomBar(tEvent, tSprID, tParam))
end
