
on construct me
return(1)
end

on deconstruct me
return(1)
end

on Refresh me, tTopic, tdata
call(symbol("handle_" & tTopic), me, tdata)
return(1)
end

on handle_msgstruct_objects me, tdata
tList = []
tCount = tdata.content.count(#line)
i = 1
if i <= tCount then -- jump 400 -- backjump 402 landing
tLine = tdata.content.getProp(#line, i)
if length(tLine) > 5 then -- jump 361
tObj = [:]
tObj[#id] = tLine.getProp(#word, 1)
tObj[#class] = tLine.getProp(#word, 2)
tObj[#x] = integer(tLine.getProp(#word, 3))
tObj[#y] = integer(tLine.getProp(#word, 4))
tObj[#h] = integer(tLine.getProp(#word, 5))
if tLine.count(#word)  = 6 then -- jump 52
tdir = integer(tLine.getProp(#word, 6)) mod 8
tObj[#direction] = [tdir, tdir, tdir]
tObj[#dimensions] = 0
 -- jump 111
end if -- jump 52 landing
tWidth = integer(tLine.getProp(#word, 6))
tHeight = integer(tLine.getProp(#word, 7))
tObj[#dimensions] = [tWidth, tHeight]
tObj[#x] = tObj[#x] + tObj[#width] - 1
tObj[#y] = tObj[#y] + tObj[#height] - 1
end if -- jump 111 landing
tVarKey = "snowwar.object_" & tObj[#class] & ".height"
if variableExists(tVarKey) then -- jump 21
tObj[#height] = getIntVariable(tVarKey)
 -- jump 12
end if -- jump 21 landing
tObj[#height] = 0
end if -- jump 12 landing
if tObj[#id] <> EMPTY then -- jump 11
tList.add(tObj)
end if -- jump 11 landing
end if -- jump 361 landing
i = 1 + i
 -- backjump 402
end if -- jump 400 landing
return(me.getGameSystem().getWorld().storeObjects(tList))
end

on handle_msgstruct_instancelist me, tMsg
tConn = tMsg.connection
tResult = [:]
tCreatedCount = tConn.GetIntFrom()
i = 1
if i <= tCreatedCount then -- jump 43 -- backjump 46 landing
tInstance = me.parse_created_instance(tConn)
tResult.addProp(string(tInstance[#id]), tInstance)
i = 1 + i
 -- backjump 46
end if -- jump 43 landing
tStartedCount = tConn.GetIntFrom()
i = 1
if i <= tStartedCount then -- jump 43 -- backjump 46 landing
tInstance = me.parse_started_instance(tConn)
tResult.addProp(string(tInstance[#id]), tInstance)
i = 1 + i
 -- backjump 46
end if -- jump 43 landing
tFinishedCount = tConn.GetIntFrom()
i = 1
if i <= tFinishedCount then -- jump 43 -- backjump 46 landing
tInstance = me.parse_finished_instance(tConn)
tResult.addProp(string(tInstance[#id]), tInstance)
i = 1 + i
 -- backjump 46
end if -- jump 43 landing
return(me.getGameSystem().sendGameSystemEvent(#instancelist, tResult))
return(tResult)
end

on handle_msgstruct_gameinstance me, tMsg
tConn = tMsg.connection
tStateInt = tConn.GetIntFrom()
tstate = [#created, #started, #finished][tStateInt + 1]
 --PEEKFROMSTACK 0 if tstate  = #created then -- jump 158
tResult = me.parse_created_instance(tConn)
tResult.addProp(#numSpectators, tConn.GetIntFrom())
tNumTeams = tConn.GetIntFrom()
tTeams = []
i = 1
if i <= tNumTeams then -- jump 80 -- backjump 83 landing
tList = []
tNumPlayers = tConn.GetIntFrom()
j = 1
if j <= tNumPlayers then -- jump 27 -- backjump 30 landing
tList.add(me.parse_team_player(tConn))
j = 1 + j
 -- backjump 30
end if -- jump 27 landing
tTeams.add([#players: tList, #id: i])
i = 1 + i
 -- backjump 83
end if -- jump 80 landing
tResult.addProp(#numTeams, tNumTeams)
tResult.addProp(#teams, tTeams)
 -- jump 614
end if -- jump 158 landing
 --PEEKFROMSTACK 0 
--nil--  = #started
if --nil-- then -- jump 146
tResult = me.parse_started_instance(tConn)
tNumTeams = tConn.GetIntFrom()
tTeams = []
i = 1
if i <= tNumTeams then -- jump 84 -- backjump 87 landing
tList = []
tNumPlayers = tConn.GetIntFrom()
j = 1
if j <= tNumPlayers then -- jump 31 -- backjump 34 landing
tList.add([#name: tConn.GetStrFrom()])
j = 1 + j
 -- backjump 34
end if -- jump 31 landing
tTeams.add([#players: tList, #id: i])
i = 1 + i
 -- backjump 87
end if -- jump 84 landing
tResult.addProp(#numTeams, tNumTeams)
tResult.addProp(#teams, tTeams)
 -- jump 462
end if -- jump 146 landing
 --PEEKFROMSTACK 0 
--nil--  = #finished
if --nil-- then -- jump 453
tResult = me.parse_finished_instance(tConn)
tNumTeams = tConn.GetIntFrom()
tTeamsUnsorted = []
i = 1
if i <= tNumTeams then -- jump 129 -- backjump 132 landing
tList = [#players: []]
tNumPlayers = tConn.GetIntFrom()
j = 1
if j <= tNumPlayers then -- jump 64 -- backjump 67 landing
tPlayer = [:]
tPlayer.addProp(#name, tConn.GetStrFrom())
tPlayer.addProp(#score, tConn.GetIntFrom())
tList[#players].add(tPlayer)
j = 1 + j
 -- backjump 67
end if -- jump 64 landing
tList.addProp(#score, tConn.GetIntFrom())
tTeamsUnsorted.add(tList)
i = 1 + i
 -- backjump 132
end if -- jump 129 landing
tResult.addProp(#numTeams, tNumTeams)
tTeams = []
tTeamId = 1
if tTeamId <= tNumTeams then -- jump 247 -- backjump 250 landing
tList = [#players: [], #id: tTeamId, #score: tTeamsUnsorted[tTeamId][#score]]
tTeamPlayers = tTeamsUnsorted[tTeamId][#players]
j = 1
if j <= tTeamPlayers.count then -- jump 166 -- backjump 171 landing
tPlayer = [:]
tPlayer.addProp(#name, tTeamPlayers[j][#name])
tPlayer.addProp(#score, tTeamPlayers[j][#score])
tPlayerPos = 1
if tList[#players].count > 0 then -- jump 67
if tList[#players][tPlayerPos][#score] > tPlayer[#score] then -- jump 32 -- backjump 62 landing
tPlayerPos = tPlayerPos + 1
if tPlayerPos > tList[#players].count then -- jump 6
 -- jump 5
end if -- jump 6 landing
 -- backjump 62
end if -- jump 5 landing
end if -- jump 32 landing
end if -- jump 67 landing
tList[#players].addAt(tPlayerPos, tPlayer)
j = 1 + j
 -- backjump 171
end if -- jump 166 landing
tTeams.add(tList)
tTeamId = 1 + tTeamId
 -- backjump 250
end if -- jump 247 landing
tPlayerPos = 1
tResult.addProp(#teams, tTeams)
end if -- jump 453 landing
end if -- jump 462 landing
end if -- jump 614 landing
 --TRIMFROMSTACK 1 
tResult.addProp(#state, tstate)
return(me.getGameSystem().sendGameSystemEvent(#gameinstance, tResult))
end

on handle_msgstruct_fullgamestatus me, tMsg
tGameSystem = me.getGameSystem()
if tGameSystem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tConn = tMsg.connection
tdata = [:]
tStateInt = tConn.GetIntFrom()
tstate = [#created, #started, #finished][tStateInt]
tdata.addProp(#state, tstate)
tdata.addProp(#time, [#state: tstate, #time_to_next_state: tConn.GetIntFrom(), #state_duration: tConn.GetIntFrom()])
tNumObjects = tConn.GetIntFrom()
tObjectIdList = []
tGameObjects = []
i = 1
if i <= tNumObjects then -- jump 59 -- backjump 62 landing
tGameObject = me.parse_snowwar_gameobject(tConn)
if listp(tGameObject) then -- jump 29
tGameObjects.add(tGameObject)
tObjectIdList.add(string(tGameObject[#id]))
end if -- jump 29 landing
i = 1 + i
 -- backjump 62
end if -- jump 59 landing
tdata.addProp(#game_objects, tGameObjects)
tGameSystem.getVarMgr().set(#tournament_flag, tConn.GetBoolFrom())
tGameSystem.sendGameSystemEvent(#set_number_of_teams, tConn.GetIntFrom())
tGameSystem.sendGameSystemEvent(#fullgamestatus_time, tdata[#time])
tGameSystem.clearTurnBuffer()
tGameSystem.sendGameSystemEvent(#verify_game_object_id_list, tObjectIdList)
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tdata[#game_objects]) <= 1 then -- jump 65 -- backjump 68 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tGameObject = --nil--
if tGameSystem.getGameObject(tGameObject[#id])  = 0 then -- jump 18
tGameSystem.sendGameSystemEvent(#create_game_object, tGameObject)
 -- jump 15
end if -- jump 18 landing
tGameSystem.sendGameSystemEvent(#update_game_object, tGameObject)
end if -- jump 15 landing
--nil-- + 1
 -- backjump 68
end if -- jump 65 landing
 --TRIMFROMSTACK 3 
tGameSystem.sendGameSystemEvent(#update_game_visuals)
tGameSystem.startTurnManager()
return(me.parse_gamestatus(tConn))
end

on handle_msgstruct_gamestart me, tMsg
tConn = tMsg.connection
tdata = [:]
tdata.addProp(#time_until_game_end, tConn.GetIntFrom())
return(me.getGameSystem().sendGameSystemEvent(#gamestart, tdata))
end

on handle_msgstruct_gameend me, tMsg
tConn = tMsg.connection
tdata = [:]
tdata.addProp(#time_until_game_reset, tConn.GetIntFrom())
tNumTeams = tConn.GetIntFrom()
tTeamScores = []
tTeamNum = 1
if tTeamNum <= tNumTeams then -- jump 140 -- backjump 143 landing
tNumPlayers = tConn.GetIntFrom()
tPlayers = [:]
tPlayer = 1
if tPlayer <= tNumPlayers then -- jump 64 -- backjump 67 landing
tPlayerId = tConn.GetIntFrom()
tPlayerName = tConn.GetStrFrom()
tPlayerScore = tConn.GetIntFrom()
tPlayers.addProp(tPlayerName, [#id: tPlayerId, #name: tPlayerName, #score: tPlayerScore])
tPlayer = 1 + tPlayer
 -- backjump 67
end if -- jump 64 landing
if tNumPlayers > 0 then -- jump 15
tTeamScore = tConn.GetIntFrom()
 -- jump 6
end if -- jump 15 landing
tTeamScore = 0
end if -- jump 6 landing
tTeamScores.add([#players: tPlayers, #score: tTeamScore])
tTeamNum = 1 + tTeamNum
 -- backjump 143
end if -- jump 140 landing
tdata.addProp(#gameend_scores, tTeamScores)
return(me.getGameSystem().sendGameSystemEvent(#gameend, tdata))
end

on handle_msgstruct_gamereset me, tMsg
tConn = tMsg.connection
tdata = [:]
tdata.addProp(#time_until_game_start, tConn.GetIntFrom())
tNumObjects = tConn.GetIntFrom()
tGameObjects = []
tObjectIdList = []
i = 1
if i <= tNumObjects then -- jump 59 -- backjump 62 landing
tGameObject = me.parse_snowwar_gameobject(tConn)
if listp(tGameObject) then -- jump 29
tGameObjects.add(tGameObject)
tObjectIdList.add(string(tGameObject[#id]))
end if -- jump 29 landing
i = 1 + i
 -- backjump 62
end if -- jump 59 landing
tdata.addProp(#game_objects, tGameObjects)
tGameSystem = me.getGameSystem()
tGameSystem.clearTurnBuffer()
tGameSystem.sendGameSystemEvent(#verify_game_object_id_list, tObjectIdList)
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tdata[#game_objects]) <= 1 then -- jump 65 -- backjump 68 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tGameObject = --nil--
if tGameSystem.getGameObject(tGameObject[#id])  = 0 then -- jump 18
tGameSystem.sendGameSystemEvent(#create_game_object, tGameObject)
 -- jump 15
end if -- jump 18 landing
tGameSystem.sendGameSystemEvent(#update_game_object, tGameObject)
end if -- jump 15 landing
--nil-- + 1
 -- backjump 68
end if -- jump 65 landing
 --TRIMFROMSTACK 3 
tGameSystem.sendGameSystemEvent(#update_game_visuals)
return(tGameSystem.sendGameSystemEvent(#gamereset, tdata))
end

on handle_msgstruct_gameplayerinfo me, tMsg
tConn = tMsg.connection
tdata = [:]
tNumPlayers = tConn.GetIntFrom()
i = 1
if i <= tNumPlayers then -- jump 68 -- backjump 71 landing
tID = tConn.GetIntFrom()
tValue = tConn.GetStrFrom()
tSkill = tConn.GetStrFrom()
tdata.addProp(string(tID), [#id: tID, #skillvalue: tValue, #skilllevel: tSkill])
i = 1 + i
 -- backjump 71
end if -- jump 68 landing
return(me.getGameSystem().sendGameSystemEvent(#gameplayerinfo, tdata))
end

on handle_msgstruct_gamestatus me, tMsg
tConn = tMsg.connection
return(me.parse_gamestatus(tConn))
end

on parse_gamestatus me, tConn
tGameSystem = me.getGameSystem()
if tGameSystem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tTurnNum = tConn.GetIntFrom()
tCheckSum = tConn.GetIntFrom()
tNumSubturns = tConn.GetIntFrom()
tTurn = tGameSystem.getNewTurnContainer()
if not objectp(tTurn) then -- jump 18
return(error(me, "Cannot create turn container!", #parse_gamestatus))
end if -- jump 18 landing
tTurn.SetNumber(tTurnNum)
tTurn.SetChecksum(tCheckSum)
tSubTurnIndex = []
tSubTurnNum = 1
if tSubTurnNum <= tNumSubturns then -- jump 117 -- backjump 120 landing
tSubTurnIndex[tSubTurnNum] = []
tNumEvents = tConn.GetIntFrom()
tEventNum = 1
if tEventNum <= tNumEvents then -- jump 56 -- backjump 59 landing
tEvent = me.parse_event(tConn)
if tEvent  = 0 then -- jump 18
return(error(me, "SERVER ERROR: No event received when expected!", #parse_gamestatus))
end if -- jump 18 landing
tTurn.AddElement(tSubTurnNum, tEvent)
tEventNum = 1 + tEventNum
 -- backjump 59
end if -- jump 56 landing
if tNumEvents  = 0 then -- jump 16
tTurn.AddElement(tSubTurnNum, void())
end if -- jump 16 landing
tSubTurnNum = 1 + tSubTurnNum
 -- backjump 120
end if -- jump 117 landing
return(tGameSystem.sendGameSystemEvent(#gamestatus_turn, tTurn))
end

on parse_snowwar_gameobject me, tConn
tdata = [:]
tdata.addProp(#type, tConn.GetIntFrom())
tID = tConn.GetIntFrom()
tdata.addProp(#int_id, tID)
tdata.addProp(#id, string(tID))
 --PEEKFROMSTACK 0 if tdata[#type]  = 0 then -- jump 46
tObjectData = me.parse_snowwar_player_gameobjectvariables(tdata.duplicate(), tConn)
tdata.addProp(#objectDataStruct, tObjectData)
tdata.addProp(#str_type, "player")
 -- jump 388
end if -- jump 46 landing
 --PEEKFROMSTACK 0 
--nil--  = 1
if --nil-- then -- jump 46
tObjectData = me.parse_snowwar_snowball_gameobjectvariables(tdata.duplicate(), tConn)
tdata.addProp(#objectDataStruct, tObjectData)
tdata.addProp(#str_type, "snowball")
 -- jump 337
end if -- jump 46 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 13
 --TRIMFROMSTACK 1 
return(0)
 -- jump 319
end if -- jump 13 landing
 --PEEKFROMSTACK 0 
--nil--  = 3
if --nil-- then -- jump 46
tObjectData = me.parse_snowwar_large_snowball_gameobjectvariables(tdata.duplicate(), tConn)
tdata.addProp(#objectDataStruct, tObjectData)
tdata.addProp(#str_type, "large_snowball")
 -- jump 268
end if -- jump 46 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 46
tObjectData = me.parse_snowwar_snowball_machine_gameobjectvariables(tdata.duplicate(), tConn)
tdata.addProp(#objectDataStruct, tObjectData)
tdata.addProp(#str_type, "snowball_machine")
 -- jump 217
end if -- jump 46 landing
 --PEEKFROMSTACK 0 
--nil--  = 5
if --nil-- then -- jump 189
tObjectData = me.parse_snowwar_avatar_gameobjectvariables(tdata.duplicate(), tConn)
tdata.addProp(#objectDataStruct, tObjectData)
i = 1
if i <= tObjectData.count then -- jump 35 -- backjump 40 landing
tdata.addProp(tObjectData.getPropAt(i), tObjectData[i])
i = 1 + i
 -- backjump 40
end if -- jump 35 landing
tdata.addProp(#human_id, tdata[#id])
tdata.addProp(#dirBody, tdata[#body_direction])
tdata.addProp(#name, tConn.GetStrFrom())
tdata.addProp(#mission, tConn.GetStrFrom())
tdata.addProp(#figure, tConn.GetStrFrom())
tdata.addProp(#sex, tConn.GetStrFrom())
tdata.addProp(#str_type, "avatar")
 -- jump 23
end if -- jump 189 landing
error(me, "Unsupported game object type:" && tdata[#type], #parse_snowwar_gameobject)
end if -- jump 23 landing
end if -- jump 217 landing
end if -- jump 268 landing
end if -- jump 319 landing
end if -- jump 337 landing
end if -- jump 388 landing
 --TRIMFROMSTACK 1 
tExtraProps = ["collisionshape_type", "height", "collisionshape_radius"]
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tExtraProps) <= 1 then -- jump 82 -- backjump 85 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tProp = --nil--
if variableExists("snowwar.object_" & tdata[#str_type] & "." & tProp) then -- jump 41
tdata.addProp(symbol("gameobject_" & tProp), getVariable("snowwar.object_" & tdata[#str_type] & "." & tProp))
end if -- jump 41 landing
--nil-- + 1
 -- backjump 85
end if -- jump 82 landing
 --TRIMFROMSTACK 3 
return(tdata)
end

on parse_snowwar_snowball_gameobjectvariables me, tdata, tConn
tdata.addProp(#x, tConn.GetIntFrom())
tdata.addProp(#y, tConn.GetIntFrom())
tdata.addProp(#z, tConn.GetIntFrom())
tdata.addProp(#movement_direction, tConn.GetIntFrom())
tdata.addProp(#trajectory, tConn.GetIntFrom())
tdata.addProp(#time_to_live, tConn.GetIntFrom())
tdata.addProp(#int_thrower_id, tConn.GetIntFrom())
tdata.addProp(#parabola_offset, tConn.GetIntFrom())
return(tdata)
end

on parse_snowwar_player_gameobjectvariables me, tdata, tConn
tdata.addProp(#room_index, tConn.GetIntFrom())
tdata.addProp(#human_id, tConn.GetIntFrom())
return(tdata)
end

on parse_snowwar_avatar_gameobjectvariables me, tdata, tConn
tdata.addProp(#x, tConn.GetIntFrom())
tdata.addProp(#y, tConn.GetIntFrom())
tdata.addProp(#body_direction, tConn.GetIntFrom())
tdata.addProp(#hit_points, tConn.GetIntFrom())
tdata.addProp(#snowball_count, tConn.GetIntFrom())
tdata.addProp(#is_bot, tConn.GetIntFrom())
tdata.addProp(#activity_timer, tConn.GetIntFrom())
tdata.addProp(#activity_state, tConn.GetIntFrom())
tdata.addProp(#next_tile_x, tConn.GetIntFrom())
tdata.addProp(#next_tile_y, tConn.GetIntFrom())
tdata.addProp(#move_target_x, tConn.GetIntFrom())
tdata.addProp(#move_target_y, tConn.GetIntFrom())
tdata.addProp(#score, tConn.GetIntFrom())
tdata.addProp(#player_id, tConn.GetIntFrom())
tdata.addProp(#team_id, tConn.GetIntFrom())
tdata.addProp(#room_index, tConn.GetIntFrom())
return(tdata)
end

on parse_snowwar_large_snowball_gameobjectvariables me, tdata, tConn
tdata.addProp(#x, tConn.GetIntFrom())
tdata.addProp(#y, tConn.GetIntFrom())
return(tdata)
end

on parse_snowwar_snowball_machine_gameobjectvariables me, tdata, tConn
tdata.addProp(#x, tConn.GetIntFrom())
tdata.addProp(#y, tConn.GetIntFrom())
tdata.addProp(#snowball_count, tConn.GetIntFrom())
return(tdata)
end

on parse_event me, tConn
tEventType = tConn.GetIntFrom()
 --PEEKFROMSTACK 0 if tEventType  = 0 then -- jump 27
tEvent = me.parse_snowwar_gameobject(tConn)
tEvent.addProp(#event_type, 0)
 -- jump 290
end if -- jump 27 landing
 --PEEKFROMSTACK 0 
--nil--  = 1
if --nil-- then -- jump 14
tIntKeyList = [#int_id]
 -- jump 271
end if -- jump 14 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 20
tIntKeyList = [#int_id, #x, #y]
 -- jump 246
end if -- jump 20 landing
 --PEEKFROMSTACK 0 
--nil--  = 3
if --nil-- then -- jump 20
tIntKeyList = [#int_id, #int_target_id, #throw_height]
 -- jump 221
end if -- jump 20 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 23
tIntKeyList = [#int_id, #targetX, #targetY, #throw_height]
 -- jump 193
end if -- jump 23 landing
 --PEEKFROMSTACK 0 
--nil--  = 5
if --nil-- then -- jump 18
tIntKeyList = [#int_thrower_id, #int_id, #hit_direction]
 -- jump 170
end if -- jump 18 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 17
tIntKeyList = [#x, #y]
 -- jump 148
end if -- jump 17 landing
 --PEEKFROMSTACK 0 
--nil--  = 7
if --nil-- then -- jump 14
tIntKeyList = [#int_id]
 -- jump 129
end if -- jump 14 landing
 --PEEKFROMSTACK 0 
--nil--  = 8
if --nil-- then -- jump 24
tIntKeyList = [#int_id, #int_thrower_id, #targetX, #targetY, #trajectory]
 -- jump 100
end if -- jump 24 landing
 --PEEKFROMSTACK 0 
--nil--  = 9
if --nil-- then -- jump 18
tIntKeyList = [#int_id, #int_thrower_id, #hit_direction]
 -- jump 77
end if -- jump 18 landing
 --PEEKFROMSTACK 0 
--nil--  = 10
if --nil-- then -- jump 11
tIntKeyList = []
 -- jump 61
end if -- jump 11 landing
 --PEEKFROMSTACK 0 
--nil--  = 11
if --nil-- then -- jump 14
tIntKeyList = [#int_machine_id]
 -- jump 42
end if -- jump 14 landing
 --PEEKFROMSTACK 0 
--nil--  = 12
if --nil-- then -- jump 17
tIntKeyList = [#int_player_id, #int_machine_id]
 -- jump 20
end if -- jump 17 landing
 --TRIMFROMSTACK 1 
return(error(me, "Undefined event sent by server, parsing cannot continue!", #handle_gamestatus))
end if -- jump 20 landing
end if -- jump 42 landing
end if -- jump 61 landing
end if -- jump 77 landing
end if -- jump 100 landing
end if -- jump 129 landing
end if -- jump 148 landing
end if -- jump 170 landing
end if -- jump 193 landing
end if -- jump 221 landing
end if -- jump 246 landing
end if -- jump 271 landing
end if -- jump 290 landing
 --TRIMFROMSTACK 1 
if listp(tIntKeyList) then -- jump 98
tEvent = [#event_type: tEventType]
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tIntKeyList) <= 1 then -- jump 33 -- backjump 36 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tKey = --nil--
tEvent.addProp(tKey, tConn.GetIntFrom())
--nil-- + 1
 -- backjump 36
end if -- jump 33 landing
 --TRIMFROMSTACK 3 
if tEvent.findPos(#int_id) > 0 then -- jump 24
tEvent.addProp(#id, string(tEvent[#int_id]))
end if -- jump 24 landing
end if -- jump 98 landing
return(tEvent)
end

on parse_created_instance me, tConn
tResult = [:]
tResult.addProp(#id, tConn.GetIntFrom())
tResult.addProp(#name, tConn.GetStrFrom())
tResult.addProp(#host, me.parse_team_player(tConn))
tResult.addProp(#state, #created)
tResult.addProp(#gameLength, tConn.GetIntFrom())
tResult.addProp(#fieldType, tConn.GetIntFrom())
return(tResult)
end

on parse_started_instance me, tConn
tResult = [:]
tResult.addProp(#id, tConn.GetIntFrom())
tResult.addProp(#name, tConn.GetStrFrom())
tResult.addProp(#host, [#name: tConn.GetStrFrom()])
tResult.addProp(#state, #started)
tResult.addProp(#gameLength, tConn.GetIntFrom())
tResult.addProp(#fieldType, tConn.GetIntFrom())
return(tResult)
end

on parse_finished_instance me, tConn
tResult = [:]
tResult.addProp(#id, tConn.GetIntFrom())
tResult.addProp(#name, tConn.GetStrFrom())
tResult.addProp(#host, [#name: tConn.GetStrFrom()])
tResult.addProp(#state, #finished)
tResult.addProp(#gameLength, tConn.GetIntFrom())
tResult.addProp(#fieldType, tConn.GetIntFrom())
return(tResult)
end

on parse_team_player me, tConn
tResult = [:]
tResult.addProp(#id, tConn.GetIntFrom())
tResult.addProp(#name, tConn.GetStrFrom())
return(tResult)
end

on parse_gamestatus_player me, tConn
tdata = [:]
tdata.addProp(#id, tConn.GetIntFrom())
tdata.addProp(#locX, tConn.GetIntFrom())
tdata.addProp(#locY, tConn.GetIntFrom())
tdata.addProp(#dirBody, tConn.GetIntFrom())
return(tdata)
end
