property pReady, pHiliteSpriteNum, pFramework, pAvatarAction, pInvincible, pInvincibleCounter, pTeamId, pAvatarId, pDump, pActionPartList

on construct me
pActionPartList = ["bd", "sh"]
pReady = 0
pDump = 0
pAvatarAction = [:]
pAvatarAction[#tag] = EMPTY
if not objectp(me.ancestor) then -- jump 8
return(0)
end if -- jump 8 landing
return(me.ancestor.construct())
end

on deconstruct me
pReady = 0
if pHiliteSpriteNum > 0 then -- jump 9
releaseSprite(pHiliteSpriteNum)
end if -- jump 9 landing
if not objectp(me.ancestor) then -- jump 9
return(1)
end if -- jump 9 landing
return(me.ancestor.deconstruct())
end

on define me, tdata
me.pPartClass = getVariableValue("snowwar.bodypart.class")
pTeamId = string(tdata[#team_id])
pAvatarId = string(tdata[#human_id])
callAncestor(#define, me, tdata)
 --PEEKFROMSTACK 0 if tdata[#activity_state]  = 1 then -- jump 14
me.gameObjectAction("start_create")
 -- jump 69
end if -- jump 14 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 45
tParams = [:]
tParams.addProp(#hit_direction, tdata[#body_direction])
me.gameObjectAction("start_stunned", tParams)
me.gameObjectAction("next_stunned")
 -- jump 19
end if -- jump 45 landing
 --PEEKFROMSTACK 0 
--nil--  = 3
if --nil-- then -- jump 11
me.gameObjectAction("start_invincible")
end if -- jump 11 landing
end if -- jump 19 landing
end if -- jump 69 landing
 --TRIMFROMSTACK 1 
pReady = 1
me.setOwnHiliter(1)
return(1)
end

on select me
if pFramework  = void() then -- jump 11
pFramework = getObject(#snowwar_gamesystem)
end if -- jump 11 landing
if pFramework.getGamestatus() <> #game_started then -- jump 8
return(0)
end if -- jump 8 landing
if pFramework.getSpectatorModeFlag() then -- jump 8
return(0)
end if -- jump 8 landing
if not getObject(#session).exists("user_game_index") then -- jump 8
return(0)
end if -- jump 8 landing
tUserIndex = getObject(#session).GET("user_game_index")
if tUserIndex  = 0 then -- jump 17
return(error(me, "Own player missing the game object index!", #select))
end if -- jump 17 landing
tIsOwnAvatar = pAvatarId  = tUserIndex
if tIsOwnAvatar then -- jump 16
pFramework.executeGameObjectEvent(pAvatarId, #send_create_snowball)
 -- jump 59
end if -- jump 16 landing
if the shiftDown or the optionDown then -- jump 27
pFramework.executeGameObjectEvent(pAvatarId, #send_throw_at_player, [#target_id: pAvatarId, #trajectory: 2])
 -- jump 23
end if -- jump 27 landing
pFramework.executeGameObjectEvent(pAvatarId, #send_throw_at_player, [#target_id: pAvatarId, #trajectory: 0])
end if -- jump 23 landing
end if -- jump 59 landing
return(0)
end

on setAvatarEventListener me, tTargetID
tsprite = me.pMatteSpr
if not ilk(tsprite)  = #sprite then -- jump 8
return(0)
end if -- jump 8 landing
tsprite.registerProcedure(#eventProcSnowwarUserRollOver, tTargetID, #mouseEnter)
tsprite.registerProcedure(#eventProcSnowwarUserRollOver, tTargetID, #mouseLeave)
return(1)
end

on gameObjectRefreshLocation me, tX, tY, tH, tDirHead, tDirBody
me.resetValues(tX, tY, tH, tDirHead, tDirBody)
return(1)
end

on gameObjectNewMoveTarget me, tX, tY, tH, tDirHead, tDirBody, tAction
me.pMoveTime = 300
tX = integer(tX)
tY = integer(tY)
tH = integer(tH)
me.resetValues(me.pLocX, me.pLocY, me.pLocH, tDirHead, tDirBody)
me.setProp(#pAvatarAction, #tag, EMPTY)
me.pMainAction = "wlk"
me.pMoving = 1
if me.pGeometry  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
me.pStartLScreen = me.pGeometry.getScreenCoordinate(me.pLocX, me.pLocY, me.pLocH)
me.pDestLScreen = me.pGeometry.getScreenCoordinate(tX, tY, tH)
me.pMoveStart = the milliSeconds
call(#defineAct, me.getDefinedPartList(pActionPartList), "wlk")
me.Refresh(me.pLocX, me.pLocY, me.pLocH)
return(1)
end

on gameObjectMoveDone me, tX, tY, tH, tDirHead, tDirBody, tAction
me.pAnimCounter = 0
me.resetValues(tX, tY, tH, tDirHead, tDirBody)
call(#reset, me.pPartList)
me.setHumanSpriteLoc()
me.setOwnHiliter(1)
return(1)
end

on gameObjectAction me, tAction, tdata
 --PEEKFROMSTACK 0 if tAction  = "start_throw" then -- jump 96
me.resetValues(me.pLocX, me.pLocY, me.pLocH, tdata, tdata)
me.Refresh(me.pLocX, me.pLocY, me.pLocH)
call(#defineAct, me.getDefinedPartList(pActionPartList), "tr1")
me.pChanges = 1
pAvatarAction[#tag] = "throw"
 --TRIMFROMSTACK 1 
return(me.delay(100, #gameObjectAction, "next_throw"))
 -- jump 838
end if -- jump 96 landing
 --PEEKFROMSTACK 0 
--nil--  = "next_throw"
if --nil-- then -- jump 100
if pAvatarAction[#tag] <> "throw" then -- jump 11
 --TRIMFROMSTACK 1 
return(1)
end if -- jump 11 landing
pAvatarAction[#tag] = EMPTY
call(#reset, me.pPartList)
me.pChanges = 1
call(#defineAct, me.getDefinedPartList(pActionPartList), "tr2")
if pDump then -- jump 9
put("next_throw calling timer_reset_figure")
end if -- jump 9 landing
 --TRIMFROMSTACK 1 
return(me.delay(300, #gameObjectAction, "timer_reset_figure"))
 -- jump 733
end if -- jump 100 landing
 --PEEKFROMSTACK 0 
--nil--  = "timer_reset_figure"
if --nil-- then -- jump 38
if pAvatarAction[#tag] <> EMPTY then -- jump 11
 --TRIMFROMSTACK 1 
return(1)
end if -- jump 11 landing
me.gameObjectAction("reset_figure", tdata)
 -- jump 690
end if -- jump 38 landing
 --PEEKFROMSTACK 0 
--nil--  = "reset_figure"
if --nil-- then -- jump 122
me.pInvincible = 0
me.pMainAction = "std"
if pAvatarAction.findPos(#originaldirection) > 0 then -- jump 15
me.pDirection = pAvatarAction[#originaldirection]
end if -- jump 15 landing
pAvatarAction[#tag] = EMPTY
if ilk(me.pSprite)  = #sprite then -- jump 11
me.pSprite.blend = 100
end if -- jump 11 landing
me.resetValues(me.pLocX, me.pLocY, me.pLocH, me.pDirection, me.pDirection)
me.arrangeParts()
call(#reset, me.pPartList)
me.pChanges = 1
 -- jump 563
end if -- jump 122 landing
 --PEEKFROMSTACK 0 
--nil--  = "start_create"
if --nil-- then -- jump 82
pAvatarAction[#tag] = EMPTY
tDirection = me.pDirection - me.pDirection mod 2
call(#defineDir, me.pPartList, tDirection)
me.pMainAction = "pck"
call(#defineAct, me.getDefinedPartList(pActionPartList), "pck")
me.pChanges = 1
me.arrangeParts()
me.render()
 -- jump 476
end if -- jump 82 landing
 --PEEKFROMSTACK 0 
--nil--  = "start_stunned"
if --nil-- then -- jump 276
me.gameObjectMoveDone(me.pLocX, me.pLocY, me.pLocH, me.pDirection, me.pDirection)
tBallDirection = tdata[#hit_direction] - tdata[#hit_direction] mod 2
tMyDirection = me.pDirection - me.pDirection mod 2
if tBallDirection <> tMyDirection and tBallDirection mod 4  = tMyDirection mod 4 then -- jump 14
tDeathDirection = tMyDirection
tFaceUp = 1
 -- jump 10
end if -- jump 14 landing
tDeathDirection = tBallDirection
tFaceUp = 0
end if -- jump 10 landing
pAvatarAction[#direction] = tDeathDirection
pAvatarAction[#originaldirection] = me.pDirection
pAvatarAction[#frame] = 1
pAvatarAction[#tag] = "dead"
if tFaceUp then -- jump 25
pAvatarAction[#facedown] = 0
pAvatarAction[#member] = "fb"
 -- jump 23
end if -- jump 25 landing
pAvatarAction[#facedown] = 1
pAvatarAction[#member] = "ff"
end if -- jump 23 landing
me.pDirection = tDeathDirection
call(#defineDir, me.pPartList, me.pDirection)
call(#defineAct, me.getDefinedPartList(pActionPartList), pAvatarAction[#member] & "1")
me.pMainAction = "std"
me.arrangeParts()
me.render()
 --TRIMFROMSTACK 1 
return(me.delay(80, #gameObjectAction, "next_stunned"))
 -- jump 195
end if -- jump 276 landing
 --PEEKFROMSTACK 0 
--nil--  = "next_stunned"
if --nil-- then -- jump 150
if pAvatarAction[#tag] <> "dead" then -- jump 17
 --TRIMFROMSTACK 1 
return(me.gameObjectAction("reset_figure"))
end if -- jump 17 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(me.pPartList) <= 1 then -- jump 24 -- backjump 27 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPart = --nil--
tPart.pAction = "foo"
--nil-- + 1
 -- backjump 27
end if -- jump 24 landing
 --TRIMFROMSTACK 3 
pAvatarAction[#frame] = 2
call(#defineDirMultiple, me.pPartList, pAvatarAction[#direction], pActionPartList)
call(#defineAct, me.getDefinedPartList(pActionPartList), pAvatarAction[#member] & "2")
me.pChanges = 1
me.arrangeParts()
me.render()
 -- jump 40
end if -- jump 150 landing
 --PEEKFROMSTACK 0 
--nil--  = "start_invincible"
if --nil-- then -- jump 32
pAvatarAction[#tag] = EMPTY
me.gameObjectAction("reset_figure")
me.pInvincible = 1
me.pInvincibleCounter = 0
end if -- jump 32 landing
end if -- jump 40 landing
end if -- jump 195 landing
end if -- jump 476 landing
end if -- jump 563 landing
end if -- jump 690 landing
end if -- jump 733 landing
end if -- jump 838 landing
 --TRIMFROMSTACK 1 
return(1)
end

on prepare me
if me.pInvincible then -- jump 35
me.pInvincibleCounter = me.pInvincibleCounter + 1
if me.pInvincibleCounter > 2 then -- jump 14
me.setBlendInvincible()
me.pInvincibleCounter = 0
end if -- jump 14 landing
end if -- jump 35 landing
me.pAnimCounter = me.pAnimCounter + 1 mod 4
if me.pMoving then -- jump 66
tFactor = float(the milliSeconds - me.pMoveStart) / me.pMoveTime
if tFactor > 1.0 then -- jump 10
tFactor = 1.0
end if -- jump 10 landing
me.pScreenLoc = me.pDestLScreen - me.pStartLScreen * tFactor + me.pStartLScreen
me.pChanges = 1
end if -- jump 66 landing
end

on update me
if pAvatarAction[#tag]  = "dead" then -- jump 9
return(1)
end if -- jump 9 landing
me.pSync = not me.pSync
if me.pSync then -- jump 12
me.prepare()
 -- jump 9
end if -- jump 12 landing
me.render()
end if -- jump 9 landing
end

on render me
if not me.pChanges then -- jump 8
return(0)
end if -- jump 8 landing
if not pReady then -- jump 8
return(0)
end if -- jump 8 landing
me.pChanges = 0
if me.pMainAction  = "sit" then -- jump 54
tSize = me.getProp(#pCanvasSize, #std)
me.pShadowSpr.castNum = getmemnum(me.pPeopleSize & "_sit_sd_001_" & me.getProp(#pFlipList, me.pDirection + 1) & "_0")
 -- jump 140
end if -- jump 54 landing
if me.pMainAction  = "lay" then -- jump 30
tSize = me.getProp(#pCanvasSize, #lay)
me.pShadowSpr.castNum = 0
me.pShadowFix = 0
 -- jump 103
end if -- jump 30 landing
tSize = me.getProp(#pCanvasSize, #std)
if pAvatarAction[#tag]  = "dead" then -- jump 53
me.pShadowSpr.castNum = 0
tSize = [62, 40, 32, 0]
me.pMember.regPoint = point(0, tSize[2] + tSize[4])
 -- jump 27
end if -- jump 53 landing
if me.pShadowSpr.member <> me.pDefShadowMem then -- jump 13
me.pShadowSpr.member = me.pDefShadowMem
end if -- jump 13 landing
end if -- jump 27 landing
end if -- jump 103 landing
end if -- jump 140 landing
if me.pBuffer.width <> tSize[1] or me.pBuffer.height <> tSize[2] then -- jump 196
me.pMember.image = image(tSize[1], tSize[2], tSize[3])
me.pMember.regPoint = point(0, tSize[2] + tSize[4])
me.pSprite.width = tSize[1]
me.pSprite.height = tSize[2]
me.pMatteSpr.width = tSize[1]
me.pMatteSpr.height = tSize[2]
me.pBuffer = image(tSize[1], tSize[2], tSize[3])
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(me.pPartList) <= 1 then -- jump 24 -- backjump 27 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPart = --nil--
tPart.resetMemberCache()
--nil-- + 1
 -- backjump 27
end if -- jump 24 landing
 --TRIMFROMSTACK 3 
end if -- jump 196 landing
me.pMember.regPoint = point(0, me.pMember.getProp(#regPoint, 2))
me.pShadowFix = 0
if me.pSprite.flipH then -- jump 24
me.pSprite.flipH = 0
me.pMatteSpr.flipH = 0
me.pShadowSpr.flipH = 0
end if -- jump 24 landing
if pAvatarAction[#tag]  = "dead" then -- jump 436
if pAvatarAction[#frame]  = 1 then -- jump 201
if pAvatarAction[#facedown] then -- jump 98
 --PEEKFROMSTACK 0 if pAvatarAction[#direction]  = 0 then -- jump 16
tpoint = point(-8, 0)
 -- jump 65
end if -- jump 16 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 18
tpoint = point(-10, -2)
 -- jump 42
end if -- jump 18 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 17
tpoint = point(35, -5)
 -- jump 20
end if -- jump 17 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 12
tpoint = point(37, 0)
end if -- jump 12 landing
end if -- jump 20 landing
end if -- jump 42 landing
end if -- jump 65 landing
 --TRIMFROMSTACK 1 
 -- jump 92
end if -- jump 98 landing
 --PEEKFROMSTACK 0 if pAvatarAction[#direction]  = 0 then -- jump 17
tpoint = point(10, -3)
 -- jump 61
end if -- jump 17 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 15
tpoint = point(30, 0)
 -- jump 41
end if -- jump 15 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 14
tpoint = point(0, 0)
 -- jump 22
end if -- jump 14 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 14
tpoint = point(17, -3)
end if -- jump 14 landing
end if -- jump 22 landing
end if -- jump 41 landing
end if -- jump 61 landing
 --TRIMFROMSTACK 1 
end if -- jump 92 landing
 -- jump 209
end if -- jump 201 landing
if pAvatarAction[#facedown] then -- jump 102
 --PEEKFROMSTACK 0 if pAvatarAction[#direction]  = 0 then -- jump 18
tpoint = point(-15, -10)
 -- jump 67
end if -- jump 18 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 18
tpoint = point(-12, -36)
 -- jump 44
end if -- jump 18 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 17
tpoint = point(38, -36)
 -- jump 22
end if -- jump 17 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 14
tpoint = point(42, -10)
end if -- jump 14 landing
end if -- jump 22 landing
end if -- jump 44 landing
end if -- jump 67 landing
 --TRIMFROMSTACK 1 
 -- jump 99
end if -- jump 102 landing
 --PEEKFROMSTACK 0 if pAvatarAction[#direction]  = 0 then -- jump 17
tpoint = point(38, -27)
 -- jump 68
end if -- jump 17 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 17
tpoint = point(37, -3)
 -- jump 46
end if -- jump 17 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 18
tpoint = point(-7, -3)
 -- jump 23
end if -- jump 18 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 15
tpoint = point(-10, -26)
end if -- jump 15 landing
end if -- jump 23 landing
end if -- jump 46 landing
end if -- jump 68 landing
 --TRIMFROMSTACK 1 
end if -- jump 99 landing
end if -- jump 209 landing
me.pMember.regPoint = me.pMember.regPoint + tpoint
end if -- jump 436 landing
if me.pCorrectLocZ then -- jump 24
tOffZ = me.pLocH + me.pRestingHeight * 1000 + 2
 -- jump 7
end if -- jump 24 landing
tOffZ = 2
end if -- jump 7 landing
me.pSprite.locH = me.getProp(#pScreenLoc, 1)
me.pSprite.locV = me.getProp(#pScreenLoc, 2)
me.pMatteSpr.loc = me.pSprite.loc
me.pShadowSpr.loc = me.pSprite.loc + [me.pShadowFix, 0]
if me.pBaseLocZ <> 0 then -- jump 16
me.pSprite.locZ = me.pBaseLocZ
 -- jump 27
end if -- jump 16 landing
me.pSprite.locZ = me.getProp(#pScreenLoc, 3) + tOffZ + me.pBaseLocZ
end if -- jump 27 landing
me.pMatteSpr.locZ = me.pSprite.locZ + 1
me.pShadowSpr.locZ = me.pSprite.locZ - 3
me.pUpdateRect = rect(0, 0, 0, 0)
me.pBuffer.fill(me.pBuffer.rect, me.pAlphaColor)
call(#update, me.pPartList)
me.pMember.image.copyPixels(me.pBuffer, me.pUpdateRect, me.pUpdateRect)
me.setOwnHiliter(1)
return(1)
end

on setHumanSpriteLoc me
tOffZ = 2
if ilk(me.pSprite) <> #sprite then -- jump 8
return(0)
end if -- jump 8 landing
me.pSprite.locH = me.getProp(#pScreenLoc, 1)
me.pSprite.locV = me.getProp(#pScreenLoc, 2)
me.pSprite.locZ = me.getProp(#pScreenLoc, 3) + tOffZ
me.pMatteSpr.loc = me.pSprite.loc
me.pMatteSpr.locZ = me.pSprite.locZ + 1
me.pShadowSpr.loc = me.pSprite.loc + [me.pShadowFix, 0]
me.pShadowSpr.locZ = me.pSprite.locZ - 3
return(1)
end

on Refresh me, tX, tY, tH
call(#defineDir, me.pPartList, me.pDirection)
me.arrangeParts()
me.pChanges = 1
return(1)
end

on resetValues me, tX, tY, tH, tDirHead, tDirBody
me.pMainAction = "std"
me.pLocX = tX
me.pLocY = tY
me.pLocH = tH
if me.pGeometry  = void() then -- jump 8
return(0)
end if -- jump 8 landing
me.pScreenLoc = me.pGeometry.getScreenCoordinate(tX, tY, tH)
me.pMoving = 0
call(#reset, me.pPartList)
me.pDirection = tDirBody
me.pHeadDir = tDirHead
me.pChanges = 1
return(1)
end

on setBlendInvincible me
tsprite = me.pSprite
if ilk(tsprite) <> #sprite then -- jump 8
return(0)
end if -- jump 8 landing
if tsprite.blend < 100 then -- jump 12
tsprite.blend = 100
 -- jump 9
end if -- jump 12 landing
tsprite.blend = 20
end if -- jump 9 landing
return(1)
end

on arrangeParts me
if me.pPartList  = void() then -- jump 8
return(0)
end if -- jump 8 landing
if me.count(#pPartList)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
 --PEEKFROMSTACK 0 if 1  = pAvatarAction[#tag]  = "dead" then -- jump 12
me.arrangeParts_Death()
 -- jump 33
end if -- jump 12 landing
 --PEEKFROMSTACK 0 
--nil--  = me.pMainAction  = "pck"
if --nil-- then -- jump 12
me.arrangeParts_Pick()
 -- jump 11
end if -- jump 12 landing
callAncestor(#arrangeParts, me)
end if -- jump 11 landing
end if -- jump 33 landing
 --TRIMFROMSTACK 1 
i = 1
if i <= me.count(#pPartList) then -- jump 34 -- backjump 43 landing
me.setProp(#pPartIndex, me.getPropRef(#pPartList, i).pPart, i)
i = 1 + i
 -- backjump 43
end if -- jump 34 landing
return(1)
end

on arrangeParts_Pick me, tXFix, tYFix
if me.pPartList  = void() then -- jump 8
return(0)
end if -- jump 8 landing
tDirection = me.pDirection - me.pDirection mod 2
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(me.pPartList) <= 1 then -- jump 45 -- backjump 48 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPart = --nil--
if pActionPartList.findPos(tPart.pPart)  = 0 then -- jump 15
tPart.pXFix = 3
tPart.pYFix = 5
end if -- jump 15 landing
--nil-- + 1
 -- backjump 48
end if -- jump 45 landing
 --TRIMFROMSTACK 3 
me.pChanges = 1
return(1)
end

on arrangeParts_Death me
if me.pPartList  = void() then -- jump 8
return(0)
end if -- jump 8 landing
if pAvatarAction[#facedown] then -- jump 106
 --PEEKFROMSTACK 0 if pAvatarAction[#direction]  = 0 then -- jump 21
tHeadBelow = 1
tFace = point(-3, 11)
 -- jump 68
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 16
tFace = point(1, 9)
 -- jump 47
end if -- jump 16 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 16
tFace = point(3, 9)
 -- jump 26
end if -- jump 16 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 18
tHeadBelow = 1
tFace = point(-1, 10)
end if -- jump 18 landing
end if -- jump 26 landing
end if -- jump 47 landing
end if -- jump 68 landing
 --TRIMFROMSTACK 1 
 -- jump 103
end if -- jump 106 landing
 --PEEKFROMSTACK 0 if pAvatarAction[#direction]  = 0 then -- jump 21
tHeadBelow = 1
tFace = point(-2, 10)
 -- jump 68
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 16
tFace = point(19, 8)
 -- jump 47
end if -- jump 16 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 16
tFace = point(18, 7)
 -- jump 26
end if -- jump 16 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 18
tHeadBelow = 1
tFace = point(-1, 10)
end if -- jump 18 landing
end if -- jump 26 landing
end if -- jump 47 landing
end if -- jump 68 landing
 --TRIMFROMSTACK 1 
end if -- jump 103 landing
tActionParts = []
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pActionPartList) <= 1 then -- jump 60 -- backjump 63 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPart = --nil--
if not voidp(me.getProp(#pPartIndex, tPart)) then -- jump 27
tActionParts.add(me.getProp(#pPartList, me.getProp(#pPartIndex, tPart)))
end if -- jump 27 landing
--nil-- + 1
 -- backjump 63
end if -- jump 60 landing
 --TRIMFROMSTACK 3 
i = me.count(#pPartList)
if i >= 1 then -- jump 49 -- backjump 52 landing
tPart = me.getProp(#pPartList, i)
if pActionPartList.findPos(tPart.pPart) > 0 then -- jump 13
me.pPartList.deleteAt(i)
end if -- jump 13 landing
i = 255 + i
 -- backjump 52
end if -- jump 49 landing
tHeadBelow = 1
i = 1
if i <= tActionParts.count then -- jump 52 -- backjump 57 landing
tPart = tActionParts[i]
if tHeadBelow then -- jump 16
me.pPartList.append(tPart)
 -- jump 15
end if -- jump 16 landing
me.pPartList.addAt(i, tPart)
end if -- jump 15 landing
i = 1 + i
 -- backjump 57
end if -- jump 52 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(me.pPartList) <= 1 then -- jump 49 -- backjump 52 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPart = --nil--
if pActionPartList.findPos(tPart.pPart)  = 0 then -- jump 19
tPart.pXFix = tFace.locH
tPart.pYFix = tFace.locV
end if -- jump 19 landing
--nil-- + 1
 -- backjump 52
end if -- jump 49 landing
 --TRIMFROMSTACK 3 
me.pChanges = 1
return(1)
end

on getPartListNameBase me
return("snowwar.human.parts")
end

on setPartLists me, tmodels
tmodels = me.fixSnowWarFigure(tmodels)
callAncestor(#setPartLists, me, tmodels)
return(1)
end

on fixSnowWarFigure me, tFigure
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pActionPartList) <= 1 then -- jump 80 -- backjump 83 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPartSymbol = --nil--
if voidp(tFigure[tPartSymbol]) then -- jump 14
tFigure[tPartSymbol] = [:]
end if -- jump 14 landing
tFigure[tPartSymbol]["model"] = "snowwar"
tFigure[tPartSymbol]["color"] = rgb("EEEEEE")
--nil-- + 1
 -- backjump 83
end if -- jump 80 landing
 --TRIMFROMSTACK 3 
if getObject(#session).GET("game_number_of_teams") > 1 then -- jump 25
tTeamColor = rgb(string(getVariable("snowwar.teamcolors.team" & pTeamId)))
 -- jump 46
end if -- jump 25 landing
if not voidp(tFigure["ch"]) then -- jump 22
tTeamColor = tFigure["ch"]["color"]
 -- jump 11
end if -- jump 22 landing
tTeamColor = rgb("EEEEEE")
end if -- jump 11 landing
end if -- jump 46 landing
if not voidp(tFigure["sh"]) then -- jump 19
tFigure["sh"]["color"] = tTeamColor
end if -- jump 19 landing
return(tFigure)
end

on setOwnHiliter me, tstate
if not getObject(#session).exists("user_index") then -- jump 8
return(0)
end if -- jump 8 landing
if me.getID() <> getObject(#session).GET("user_index") then -- jump 8
return(0)
end if -- jump 8 landing
if pHiliteSpriteNum  = 0 then -- jump 111
if not tstate then -- jump 9
return(1)
end if -- jump 9 landing
if pTeamId  = void() then -- jump 8
return(0)
end if -- jump 8 landing
pHiliteSpriteNum = reserveSprite("sw_own_hiliter_" & me.getID())
if pHiliteSpriteNum  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tsprite = sprite(pHiliteSpriteNum)
tmember = member(getmemnum("sw_avatar_hilite_team_" & pTeamId))
if tmember.type  = #bitmap then -- jump 9
tsprite.member = tmember
end if -- jump 9 landing
tsprite.visible = 1
tsprite.ink = 36
 -- jump 17
end if -- jump 111 landing
tsprite = sprite(pHiliteSpriteNum)
tsprite.visible = tstate
end if -- jump 17 landing
tsprite.locZ = me.getProp(#pScreenLoc, 3) + 1
tsprite.loc = point(me.getProp(#pScreenLoc, 1) + tsprite.member.width / 2, me.getProp(#pScreenLoc, 2))
end

on getPicture me, tImg
return(me.getPartialPicture(#Full, tImg, 4, "sh"))
end

on getTeamId me
return(pTeamId)
end

on getAvatarId me
return(pAvatarId)
end

on action_mv me, tProps
me.pMoveTime = 500
me.pMainAction = "wlk"
me.pMoving = 1
tDelim = the itemDelimiter
the itemDelimiter = ","
tloc = tProps.getProp(#word, 2)
tLocX = integer(tloc.getProp(#item, 1))
tLocY = integer(tloc.getProp(#item, 2))
tLocH = integer(tloc.getProp(#item, 3))
the itemDelimiter = tDelim
if me.pGeometry  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
me.pStartLScreen = me.pGeometry.getScreenCoordinate(me.pLocX, me.pLocY, me.pLocH)
me.pDestLScreen = me.pGeometry.getScreenCoordinate(tLocX, tLocY, tLocH)
me.pMoveStart = the milliSeconds
call(#defineAct, me.getDefinedPartList(pActionPartList), "wlk")
end
